var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Building with CMake</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Building with CMake</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"building-with-cmake\"></a></div>\n\
<p>The CMake tool is used to both to generate projects for your plug-ins and applications, and to build the plug-ins and applications from the projects it generated.</p>\n\
<p>Projects are generated by calling a CMake Generator.<br><a href=\'#!/url=./developer/Building-Your-Own-Plugin/The-CMakeList-File.html\' title=\'\'>A <span class=\'code\'>CMakeLists.txt</span> file</a> in the plug-in or application directory provides information about the libraries, files, and source needed to generate the project.</p>\n\
<p>The Maya devkit supports three generators:</p>\n\
<ul>\n\
<li><span class=\'code\'>Visual Studio 14 2015 Win64</span> for 64bit Windows</li>\n\
<li><span class=\'code\'>Unix Makefiles</span> for MacOS and Linux</li>\n\
<li><span class=\'code\'>Xcode</span> for MacOS</li>\n\
</ul>\n\
<p>Projects are generated using</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">cmake -H. -Bbuild -G &lt;generator&gt;\n\
</pre></div><p>The <span class=\'code\'>-Bbuild</span> argument is used to specify the project file target directory. You can change the target directiory by modifying this argument.</p>\n\
<p>For example, to generate an XCode poject in the <span class=\'code\'>project</span> directory, use</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">cmake -H. -Bproject -G Xcode\n\
</pre></div><p>Detailed information about generators is available in <a href=\'https://cmake.org/cmake/help/latest/manual/cmake-generators.7.html\' title=\'\' target=\'_blank\'>the CMake documentation</a>.</p>\n\
<p>After your project is generated, you can use CMake to build the plug-in or application</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">cmake --build build/\n\
</pre></div><p>You can also build the project from within Xcode or Visual Studio, depending on the generator you used.</p>\n\
<p>If you generated the project to a directory other than <span class=\'code\'>build</span>, use that directory in the call to <span class=\'code\'>cmake</span>. For example, if you generated the project to the <span class=\'code\'>project</span> directory, use</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">cmake --build project/\n\
</pre></div><p>Your built application or plug-in will be located in the top level of the <span class=\'code\'>build</span> directory if you generated your project using <span class=\'code\'>Unix Makefiles</span>. If you used the <span class=\'code\'>Xcode</span> or <span class=\'code\'>Visual Studio 14 2015 Win64</span> generator, your plug-in or application will be located under <span class=\'code\'>build</span>&#39;s <span class=\'code\'>Debug</span> subdirectory.</p>\n\
<p>You can run your applications directly from the command line or from Windows Explorer.</p>\n\
<p>If you set <span class=\'code\'>MAYA_PLUG_IN_PATH</span> path in <span class=\'code\'>Maya.env</span> as described in <a href=\'#!/url=./developer/Building-Your-Own-Plugin/Setting-up-your-build-environment.html\' title=\'\'>Setting Up Your Build Environment</a>, you can copy your plug-in to the <span class=\'code\'>MAYA_PLUG_IN_PATH</span> and it will be loaded automatically into Maya. You can also choose to not place your plug-in in <span class=\'code\'>MAYA_PLUG_IN_PATH</span> and instead <a href=\'#!/url=./developer/Loading-Samples-Plug-ins-Into-Maya.html\' title=\'\'>load it manually</a>.</p>\n\
<blockquote>\n\
<p><strong>Important:</strong> Do not rebuild a plug-in that is already loaded into Maya. <a href=\'#!/url=./developer/Unloading-Plug-ins.html\' title=\'\'>Unload the plug-in</a> before you rebuild it.</p>\n\
</blockquote>\n\
<blockquote>\n\
<p><strong>Note:</strong> Plug-ins built on different platforms will have different extensions. Plug-ins built on Windows will have the <span class=\'code\'>mll</span> extension. Plug-ins built on Linux will have the <span class=\'code\'>so</span> extension. Plug-ins built on MacOS will have the <span class=\'code\'>bundle</span> extension.</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";