var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Example: Bounding Box Deformer</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Example: Bounding Box Deformer</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"example-bounding-box-deformer\"></a></div>\n\
<div class=\'section\'><a id=\"example-bounding-box-deformer-1\"></a><h2 id=\"example-bounding-box-deformer-1\">Example: Bounding Box Deformer</h2></div>\n\
<p><strong>Filename:</strong> <span class=\'code\'>boundingBoxDeformer.py</span></p>\n\
<p><strong>Sample Output:</strong> In the following output, we assigned a green phong material to the deformed sphere. By increasing the &quot;Mesh Inflation&quot; attribute, the mesh will attempt to fill its bounding box even more.</p>\n\
<div class=\'figure\'><img src=\'developer/images/boundingBoxDeformer_75%.png\' title=\'\'></div>\n\
<p><strong>Program Summary:</strong> The plug-in code below defines a new deformer whose behavior is to &quot;inflate&quot; the mesh so that it expands within the boundaries of its bounding box. The size of this bounding box can be scaled via the &quot;Bounding Box Scale&quot; attribute so that the mesh has room to expand before hitting the boundaries of the box. The mesh&#39;s inflation is controlled via the &quot;Mesh Inflation&quot; attribute. The plug-in class inherits from <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDeformerNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_deformer_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxDeformerNode</a></span>, and overrides the <span class=\'code\'>MPxDeformer.deform()</span> function to specify its behavior. The following points are useful to keep in mind when creating a deformer node in Python:</p>\n\
<ul>\n\
<li><p><strong>Built-in Deformer Node Attributes</strong> - By inheriting from <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDeformerNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_deformer_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxDeformerNode</a></span>, your class will have access to the input and output mesh attributes, available via <span class=\'code\'>OpenMayaMPx.cvar.MPxGeometryFilter_inputGeom</span> and <span class=\'code\'>OpenMayaMPx.cvar.MPxGeometryFilter_outputGeom</span> respectively. These variables are generated by the SWIG tool during the C++ header file conversion to Python. By the same process, your deformer also has access to the built-in &quot;envelope&quot; attribute, available via <span class=\'code\'>OpenMayaMPx.cvar.MPxGeometryFilter_envelope</span>. This envelope attribute is used to specify the amount of influence your deformer has on the mesh.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> This is new for Maya 2016. In versions of Maya before Maya 2016, the input and output mesh attributes were available via <span class=\'code\'>OpenMayaMPx.cvar.MPxDeformerNode_inputGeom</span> and <span class=\'code\'>OpenMayaMPx.cvar.MPxDeformerNode_outputGeom</span> respectively, and the envelop via <span class=\'code\'>OpenMayaMPx.cvar.MPxDeformerNode_envelope</span> .</p>\n\
</blockquote></li>\n\
<li><p><strong>Obtaining the Input Geometry in deform()</strong> - The geometry iterator (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItGeometry</a></span>) passed into the <span class=\'code\'>deform()</span> function only provides you with the position of each vertex in the mesh. To obtain the normals of each vertex, you will require a reference to the actual mesh object. We define a helper function called <span class=\'code\'>getDeformerInputGeometry()</span> which returns the input mesh object. The returned mesh can thereafter be used with the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh</a></span> <em>function set</em> to retrieve the list of vertex normals, via <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh.getVertexNormals()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html#a48e776a655d6fc9cda7fef2d1a3de67f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh.getVertexNormals()</a></span>.</p></li>\n\
</ul>\n\
<p>Python API 2.0: This example is not available, as <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDeformerNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_deformer_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxDeformerNode</a></span> is not yet exposed in this API.</p>\n\
<p>Python API 1.0 (for versions earlier than Maya 2016):</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># boundingBoxDeformer.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
\n\
# Plug-in information:\n\
kPluginNodeName = &#39;boundingBoxDeformer&#39;     # The name of the node.\n\
kPluginNodeId = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MTypeId</a>( 0xBEEF8 ) # A unique ID associated to this node type.\n\
\n\
# This determines how fast the vertices of the mesh will &quot;expand&quot; towards the boundary of the bounding box.\n\
vertexIncrement = 0.1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyDeformerNode(OpenMayaMPx.MPxDeformerNode):\n\
    \n\
    # Static variable(s) which will later be replaced by the node&#39;s attribute(s).\n\
    boundingBoxScaleAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MObject</a>()\n\
    meshInflationAttribute    = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MObject</a>()\n\
    \n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        # (!) Make sure you call the base class&#39;s constructor.\n\
        OpenMayaMPx.MPxDeformerNode.__init__(self)\n\
        \n\
    \n\
    def deform(self, pDataBlock, pGeometryIterator, pLocalToWorldMatrix, pGeometryIndex):\n\
        &#39;&#39;&#39; Deform each vertex using the geometry iterator. &#39;&#39;&#39;\n\
        \n\
        # The envelope determines the overall weight of the deformer on the mesh.\n\
        # The envelope is obtained via the OpenMayaMPx.cvar.MPxDeformerNode_envelope variable.\n\
        # This variable and others like it are generated by SWIG to expose variables or constants declared in C++ header files. \n\
        envelopeAttribute = OpenMayaMPx.cvar.MPxDeformerNode_envelope\n\
        envelopeValue = pDataBlock.inputValue( envelopeAttribute ).asFloat()\n\
        \n\
        # Get the value of the mesh inflation node attribute.\n\
        meshInflationHandle = pDataBlock.inputValue( MyDeformerNode.meshInflationAttribute )\n\
        meshInflation = meshInflationHandle.asDouble()\n\
        \n\
        # Get the value of the bounding box scale node attribute.\n\
        boundingBoxScaleHandle = pDataBlock.inputValue( MyDeformerNode.boundingBoxScaleAttribute )\n\
        boundingBoxScale = boundingBoxScaleHandle.asDouble()\n\
\n\
        # Get the input mesh from the datablock using our getDeformerInputGeometry() helper function.     \n\
        inputGeometryObject = self.getDeformerInputGeometry(pDataBlock, pGeometryIndex)\n\
\n\
\n\
        # Compute the bounding box using the input the mesh.\n\
        boundingBox = self.getBoundingBox( inputGeometryObject, boundingBoxScale )\n\
\n\
        \n\
        # Obtain the list of normals for each vertex in the mesh.\n\
        normals = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFloatVectorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFloatVectorArray</a>()\n\
        meshFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnMesh</a>( inputGeometryObject )\n\
        meshFn.getVertexNormals( True, normals, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        \n\
        \n\
        # Iterate over the vertices to move them.\n\
        global vertexIncrement\n\
        while not pGeometryIterator.isDone():\n\
            \n\
            # Obtain the vertex normal of the geometry. This normal is the vertex&#39;s averaged normal value if that\n\
            # vertex is shared among several polygons.  \n\
            vertexIndex = pGeometryIterator.index()\n\
            normal = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MVector</a>( normals[vertexIndex] ) # Cast the <a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFloatVector</a> into a simple vector.\n\
            \n\
            # Increment the point along the vertex normal.\n\
            point = pGeometryIterator.position()\n\
            newPoint = point + ( normal * vertexIncrement * meshInflation * envelopeValue )\n\
                       \n\
            # Clamp the new point within the bounding box.\n\
            self.clampPointInBoundingBox( newPoint, boundingBox )\n\
            \n\
            # Set the position of the current vertex to the new point.\n\
            pGeometryIterator.setPosition( newPoint )\n\
            \n\
            # Jump to the next vertex.\n\
            pGeometryIterator.next()\n\
    \n\
    \n\
    def getDeformerInputGeometry(self, pDataBlock, pGeometryIndex):\n\
        &#39;&#39;&#39;\n\
        Obtain a reference to the input mesh. This mesh will be used to compute our bounding box, and we will also require its normals.\n\
        \n\
        We use MDataBlock.outputArrayValue() to avoid having to recompute the mesh and propagate this recomputation throughout the \n\
        Dependency Graph.\n\
        \n\
        OpenMayaMPx.cvar.MPxDeformerNode_input and OpenMayaMPx.cvar.MPxDeformerNode_inputGeom are SWIG-generated \n\
        variables which respectively contain references to the deformer&#39;s &#39;input&#39; attribute and &#39;inputGeom&#39; attribute.   \n\
        &#39;&#39;&#39;\n\
        inputAttribute = OpenMayaMPx.cvar.MPxDeformerNode_input\n\
        inputGeometryAttribute = OpenMayaMPx.cvar.MPxDeformerNode_inputGeom\n\
        \n\
        inputHandle = pDataBlock.outputArrayValue( inputAttribute )\n\
        inputHandle.jumpToElement( pGeometryIndex )\n\
        inputGeometryObject = inputHandle.outputValue().child( inputGeometryAttribute ).asMesh()\n\
        \n\
        return inputGeometryObject\n\
    \n\
    \n\
    def getBoundingBox(self, pMeshObj, pBoundingBoxScale):\n\
        &#39;&#39;&#39; Calculate a bounding box around the mesh&#39;s vertices. &#39;&#39;&#39;\n\
        \n\
        # Create the bounding box object we will populate with the points of the mesh.\n\
        boundingBox = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MBoundingBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_bounding_box.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MBoundingBox</a>()\n\
        meshFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnMesh</a>( pMeshObj )\n\
        pointArray = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MPointArray</a>()\n\
        \n\
        # Get the points of the mesh in its local coordinate space.\n\
        meshFn.getPoints( pointArray, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
\n\
        for i in range( 0, pointArray.length() ):\n\
            point = pointArray[i]\n\
            boundingBox.expand( point )\n\
        \n\
        # Expand the bounding box according to the scaling factor.\n\
        newMinPoint = boundingBox.min() * pBoundingBoxScale\n\
        newMaxPoint = boundingBox.max() * pBoundingBoxScale\n\
        boundingBox.expand( newMinPoint )\n\
        boundingBox.expand( newMaxPoint )\n\
        \n\
        return boundingBox\n\
    \n\
    \n\
    def clampPointInBoundingBox(self, pPoint, pBoundingBox):\n\
        &#39;&#39;&#39; Ensure that the given point is contained within the bounding box&#39;s min/max coordinates. &#39;&#39;&#39;\n\
        \n\
        # Define a quick clamping function for internal use within this method body.\n\
        def clamp(pValue, pMin, pMax):\n\
            return max( pMin, min( pValue, pMax ) )\n\
        \n\
        pPoint.x = clamp( pPoint.x, pBoundingBox.min().x, pBoundingBox.max().x )\n\
        pPoint.y = clamp( pPoint.y, pBoundingBox.min().y, pBoundingBox.max().y )\n\
        pPoint.z = clamp( pPoint.z, pBoundingBox.min().z, pBoundingBox.max().z )\n\
        \n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def nodeCreator():\n\
    &#39;&#39;&#39; Creates an instance of our node class and delivers it to Maya as a pointer. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( MyDeformerNode() )\n\
\n\
def nodeInitializer():\n\
    &#39;&#39;&#39; Defines the input and output attributes as static variables in our plug-in class. &#39;&#39;&#39;\n\
    # The following <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnNumericAttribute</a> function set will allow us to create our attributes.\n\
    numericAttributeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    # Define the scaling factor attribute of the bounding box around the mesh.\n\
    MyDeformerNode.boundingBoxScaleAttribute = numericAttributeFn.create( &#39;boundingBoxScale&#39;, &#39;bs&#39;, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a49b92909e3454c9fa22620dd6b8cbb60&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnNumericData.kDouble</a>, 1.5 )\n\
    numericAttributeFn.setMin( 1.0 )\n\
    numericAttributeFn.setMax( 3.0 )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setWritable( True )\n\
    numericAttributeFn.setReadable( False )\n\
    MyDeformerNode.addAttribute( MyDeformerNode.boundingBoxScaleAttribute )\n\
    \n\
    # Define a mesh inflation attribute, responsible for actually moving the vertices in the direction of their normals.\n\
    MyDeformerNode.meshInflationAttribute = numericAttributeFn.create( &#39;meshInflation&#39;, &#39;mi&#39;, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a49b92909e3454c9fa22620dd6b8cbb60&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnNumericData.kDouble</a>, 10.0 )\n\
    numericAttributeFn.setMin( 1.0 )\n\
    numericAttributeFn.setMax( 50.0 )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setWritable( True )\n\
    numericAttributeFn.setReadable( False )\n\
    MyDeformerNode.addAttribute( MyDeformerNode.meshInflationAttribute )\n\
    \n\
    &#39;&#39;&#39; The input geometry node attribute is already declared in OpenMayaMPx.cvar.MPxDeformerNode_inputGeom &#39;&#39;&#39;\n\
\n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    \n\
    &#39;&#39;&#39; The output geometry node attribute is already declared in OpenMayaMPx.cvar.MPxDeformerNode_outputGeom &#39;&#39;&#39;\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    # If any of the inputs change, the output mesh will be recomputed.\n\
    MyDeformerNode.attributeAffects( MyDeformerNode.boundingBoxScaleAttribute, OpenMayaMPx.cvar.MPxDeformerNode_outputGeom )\n\
    MyDeformerNode.attributeAffects( MyDeformerNode.meshInflationAttribute, OpenMayaMPx.cvar.MPxDeformerNode_outputGeom )\n\
    \n\
    \n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator,\n\
                              nodeInitializer, OpenMayaMPx.MPxNode.kDeformerNode )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register node: &#39; + kPluginNodeName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to deregister node: &#39; + kPluginNodeName )\n\
        raise\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;boundingBoxDeformer.py&#39; )\n\
cmds.polySphere()\n\
cmds.deformer( type=&#39;boundingBoxDeformer&#39; )\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0 (valid as of Maya 2016):</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># boundingBoxDeformer.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
\n\
# Plug-in information:\n\
kPluginNodeName = &#39;boundingBoxDeformer&#39;     # The name of the node.\n\
kPluginNodeId = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MTypeId</a>( 0xBEEF8 ) # A unique ID associated to this node type.\n\
\n\
# This determines how fast the vertices of the mesh will &quot;expand&quot; towards the boundary of the bounding box.\n\
vertexIncrement = 0.1\n\
\n\
# Some global variables were moved from <a href=\"javascript:void(0)\" data-symbol=\"MPxDeformerNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_deformer_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxDeformerNode</a> to MPxGeometryFilter. \n\
# Set some constants to the proper C++ cvars based on the API version.\n\
import maya.cmds as cmds\n\
kApiVersion = cmds.about(apiVersion=True)\n\
if kApiVersion &lt; 201600:\n\
        kInput = OpenMayaMPx.cvar.MPxDeformerNode_input\n\
        kInputGeom = OpenMayaMPx.cvar.MPxDeformerNode_inputGeom\n\
        kOutputGeom = OpenMayaMPx.cvar.MPxDeformerNode_outputGeom\n\
        kEnvelope = OpenMayaMPx.cvar.MPxDeformerNode_envelope\n\
else:\n\
        kInput = OpenMayaMPx.cvar.MPxGeometryFilter_input\n\
        kInputGeom = OpenMayaMPx.cvar.MPxGeometryFilter_inputGeom\n\
        kOutputGeom = OpenMayaMPx.cvar.MPxGeometryFilter_outputGeom\n\
        kEnvelope = OpenMayaMPx.cvar.MPxGeometryFilter_envelope\n\
\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyDeformerNode(OpenMayaMPx.MPxDeformerNode):\n\
    \n\
    # Static variable(s) which will later be replaced by the node&#39;s attribute(s).\n\
    boundingBoxScaleAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MObject</a>()\n\
    meshInflationAttribute    = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MObject</a>()\n\
    \n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        # (!) Make sure you call the base class&#39;s constructor.\n\
        OpenMayaMPx.MPxDeformerNode.__init__(self)\n\
        \n\
    \n\
    def deform(self, pDataBlock, pGeometryIterator, pLocalToWorldMatrix, pGeometryIndex):\n\
        &#39;&#39;&#39; Deform each vertex using the geometry iterator. &#39;&#39;&#39;\n\
        \n\
        # The envelope determines the overall weight of the deformer on the mesh.\n\
        # The envelope is obtained via the OpenMayaMPx.cvar.MPxDeformerNode_envelope (pre Maya 2016) or\n\
        # OpenMayaMPx.cvar.MPxGeometryFilter_envelope (Maya 2016) variable.\n\
        # This variable and others like it are generated by SWIG to expose variables or constants declared in C++ header files. \n\
        envelopeAttribute = kEnvelope\n\
        envelopeValue = pDataBlock.inputValue( envelopeAttribute ).asFloat()\n\
        \n\
        # Get the value of the mesh inflation node attribute.\n\
        meshInflationHandle = pDataBlock.inputValue( MyDeformerNode.meshInflationAttribute )\n\
        meshInflation = meshInflationHandle.asDouble()\n\
        \n\
        # Get the value of the bounding box scale node attribute.\n\
        boundingBoxScaleHandle = pDataBlock.inputValue( MyDeformerNode.boundingBoxScaleAttribute )\n\
        boundingBoxScale = boundingBoxScaleHandle.asDouble()\n\
\n\
        # Get the input mesh from the datablock using our getDeformerInputGeometry() helper function.     \n\
        inputGeometryObject = self.getDeformerInputGeometry(pDataBlock, pGeometryIndex)\n\
\n\
\n\
        # Compute the bounding box using the input the mesh.\n\
        boundingBox = self.getBoundingBox( inputGeometryObject, boundingBoxScale )\n\
\n\
        \n\
        # Obtain the list of normals for each vertex in the mesh.\n\
        normals = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFloatVectorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFloatVectorArray</a>()\n\
        meshFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnMesh</a>( inputGeometryObject )\n\
        meshFn.getVertexNormals( True, normals, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        \n\
        \n\
        # Iterate over the vertices to move them.\n\
        global vertexIncrement\n\
        while not pGeometryIterator.isDone():\n\
            \n\
            # Obtain the vertex normal of the geometry. This normal is the vertex&#39;s averaged normal value if that\n\
            # vertex is shared among several polygons.  \n\
            vertexIndex = pGeometryIterator.index()\n\
            normal = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MVector</a>( normals[vertexIndex] ) # Cast the <a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFloatVector</a> into a simple vector.\n\
            \n\
            # Increment the point along the vertex normal.\n\
            point = pGeometryIterator.position()\n\
            newPoint = point + ( normal * vertexIncrement * meshInflation * envelopeValue )\n\
                       \n\
            # Clamp the new point within the bounding box.\n\
            self.clampPointInBoundingBox( newPoint, boundingBox )\n\
            \n\
            # Set the position of the current vertex to the new point.\n\
            pGeometryIterator.setPosition( newPoint )\n\
            \n\
            # Jump to the next vertex.\n\
            pGeometryIterator.next()\n\
    \n\
    \n\
    def getDeformerInputGeometry(self, pDataBlock, pGeometryIndex):\n\
        &#39;&#39;&#39;\n\
        Obtain a reference to the input mesh. This mesh will be used to compute our bounding box, and we will also require its normals.\n\
        \n\
        We use MDataBlock.outputArrayValue() to avoid having to recompute the mesh and propagate this recomputation throughout the \n\
        Dependency Graph.\n\
        \n\
        OpenMayaMPx.cvar.MPxDeformerNode_input and OpenMayaMPx.cvar.MPxDeformerNode_inputGeom (for pre Maya 2016) and \n\
        OpenMayaMPx.cvar.MPxGeometryFilter_input and OpenMayaMPx.cvar.MPxGeometryFilter_inputGeom (Maya 2016) are SWIG-generated \n\
        variables which respectively contain references to the deformer&#39;s &#39;input&#39; attribute and &#39;inputGeom&#39; attribute.   \n\
        &#39;&#39;&#39;\n\
        inputAttribute = OpenMayaMPx.cvar.MPxGeometryFilter_input\n\
        inputGeometryAttribute = OpenMayaMPx.cvar.MPxGeometryFilter_inputGeom\n\
        \n\
        inputHandle = pDataBlock.outputArrayValue( inputAttribute )\n\
        inputHandle.jumpToElement( pGeometryIndex )\n\
        inputGeometryObject = inputHandle.outputValue().child( inputGeometryAttribute ).asMesh()\n\
        \n\
        return inputGeometryObject\n\
    \n\
    \n\
    def getBoundingBox(self, pMeshObj, pBoundingBoxScale):\n\
        &#39;&#39;&#39; Calculate a bounding box around the mesh&#39;s vertices. &#39;&#39;&#39;\n\
        \n\
        # Create the bounding box object we will populate with the points of the mesh.\n\
        boundingBox = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MBoundingBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_bounding_box.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MBoundingBox</a>()\n\
        meshFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnMesh</a>( pMeshObj )\n\
        pointArray = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MPointArray</a>()\n\
        \n\
        # Get the points of the mesh in its local coordinate space.\n\
        meshFn.getPoints( pointArray, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
\n\
        for i in range( 0, pointArray.length() ):\n\
            point = pointArray[i]\n\
            boundingBox.expand( point )\n\
        \n\
        # Expand the bounding box according to the scaling factor.\n\
        newMinPoint = boundingBox.min() * pBoundingBoxScale\n\
        newMaxPoint = boundingBox.max() * pBoundingBoxScale\n\
        boundingBox.expand( newMinPoint )\n\
        boundingBox.expand( newMaxPoint )\n\
        \n\
        return boundingBox\n\
    \n\
    \n\
    def clampPointInBoundingBox(self, pPoint, pBoundingBox):\n\
        &#39;&#39;&#39; Ensure that the given point is contained within the bounding box&#39;s min/max coordinates. &#39;&#39;&#39;\n\
        \n\
        # Define a quick clamping function for internal use within this method body.\n\
        def clamp(pValue, pMin, pMax):\n\
            return max( pMin, min( pValue, pMax ) )\n\
        \n\
        pPoint.x = clamp( pPoint.x, pBoundingBox.min().x, pBoundingBox.max().x )\n\
        pPoint.y = clamp( pPoint.y, pBoundingBox.min().y, pBoundingBox.max().y )\n\
        pPoint.z = clamp( pPoint.z, pBoundingBox.min().z, pBoundingBox.max().z )\n\
        \n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def nodeCreator():\n\
    &#39;&#39;&#39; Creates an instance of our node class and delivers it to Maya as a pointer. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( MyDeformerNode() )\n\
\n\
def nodeInitializer():\n\
    &#39;&#39;&#39; Defines the input and output attributes as static variables in our plug-in class. &#39;&#39;&#39;\n\
    # The following <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnNumericAttribute</a> function set will allow us to create our attributes.\n\
    numericAttributeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    # Define the scaling factor attribute of the bounding box around the mesh.\n\
    MyDeformerNode.boundingBoxScaleAttribute = numericAttributeFn.create( &#39;boundingBoxScale&#39;, &#39;bs&#39;, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a49b92909e3454c9fa22620dd6b8cbb60&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnNumericData.kDouble</a>, 1.5 )\n\
    numericAttributeFn.setMin( 1.0 )\n\
    numericAttributeFn.setMax( 3.0 )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setWritable( True )\n\
    numericAttributeFn.setReadable( False )\n\
    MyDeformerNode.addAttribute( MyDeformerNode.boundingBoxScaleAttribute )\n\
    \n\
    # Define a mesh inflation attribute, responsible for actually moving the vertices in the direction of their normals.\n\
    MyDeformerNode.meshInflationAttribute = numericAttributeFn.create( &#39;meshInflation&#39;, &#39;mi&#39;, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a49b92909e3454c9fa22620dd6b8cbb60&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnNumericData.kDouble</a>, 10.0 )\n\
    numericAttributeFn.setMin( 1.0 )\n\
    numericAttributeFn.setMax( 50.0 )\n\
    numericAttributeFn.setStorable( True )\n\
    numericAttributeFn.setWritable( True )\n\
    numericAttributeFn.setReadable( False )\n\
    MyDeformerNode.addAttribute( MyDeformerNode.meshInflationAttribute )\n\
    \n\
    &#39;&#39;&#39; The input geometry node attribute is already declared in OpenMayaMPx.cvar.MPxGeometryFilter_inputGeom &#39;&#39;&#39;\n\
\n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    \n\
    &#39;&#39;&#39; The output geometry node attribute is already declared in OpenMayaMPx.cvar.MPxGeometryFilter_outputGeom &#39;&#39;&#39;\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    # If any of the inputs change, the output mesh will be recomputed.\n\
    \n\
    print dir(OpenMayaMPx.cvar)\n\
    \n\
    MyDeformerNode.attributeAffects( MyDeformerNode.boundingBoxScaleAttribute, kOutputGeom )\n\
    MyDeformerNode.attributeAffects( MyDeformerNode.meshInflationAttribute, kOutputGeom )\n\
    \n\
    \n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator,\n\
                              nodeInitializer, OpenMayaMPx.MPxNode.kDeformerNode )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register node: &#39; + kPluginNodeName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to deregister node: &#39; + kPluginNodeName )\n\
        raise\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;boundingBoxDeformer.py&#39; )\n\
cmds.polySphere()\n\
cmds.deformer( type=&#39;boundingBoxDeformer&#39; )\n\
\n\
&#39;&#39;&#39;\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";