var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Shape classes</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Shape classes</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"shape-classes\"></a></div>\n\
<p>The following lists the proxy classes you will be deriving from:</p>\n\
<ul>\n\
<li><a href=\'#!/url=./developer/Shapes/Shape-classes.html#mpxsurfaceshape-or-mpxcomponentshape--required-\' title=\'\'>MPxSurfaceShape or MPxComponentShape (required)</a>: the DG node class</li>\n\
<li><a href=\'#!/url=./developer/Shapes/Shape-classes.html#mpxsurfaceshapeui--required-\' title=\'\'>MPxSurfaceShapeUI (required)</a>: drawing and selection</li>\n\
<li><a href=\'#!/url=./developer/Shapes/Shape-classes.html#mpxgeometryiterator--optional-\' title=\'\'>MPxGeometryIterator (optional)</a>: iterator for components (optional)</li>\n\
<li><a href=\'#!/url=./developer/Shapes/Shape-classes.html#mpxgeometrydata--optional-\' title=\'\'>MPxGeometryData (optional)</a>: used to pass geometry through the DG</li>\n\
<li>&quot;MTextureEditorDrawInfo (optional)&quot;: used by the drawUV() method of MPxSurfaceShapeUI to specify the current object drawing state</li>\n\
</ul>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSurfaceShape</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShapeUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSurfaceShapeUI</a></span> are mandatory. The main functionality for shapes is split between these two classes to separate the drawing and selection code from the evaluation code.</p>\n\
<div class=\'section\'><a id=\"mpxsurfaceshape-or-mpxcomponentshape-required\"></a><h2 id=\"mpxsurfaceshape-or-mpxcomponentshape-required\">MPxSurfaceShape or MPxComponentShape (required)</h2></div>\n\
<p>This class defines the non UI part of a shape. The goal of this class is to represent some user-defined geometry in Maya’s DAG. The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxComponentShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_component_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxComponentShape</a></span> class derives from <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSurfaceShape</a></span> and provides basic functionality for supporting shapes with components.</p>\n\
<div class=\'section\'><a id=\"mpxsurfaceshapeui-required\"></a><h2 id=\"mpxsurfaceshapeui-required\">MPxSurfaceShapeUI (required)</h2></div>\n\
<p>This class defines the drawing and selection part of a shape.</p>\n\
<div class=\'section\'><a id=\"mpxgeometryiterator-optional\"></a><h2 id=\"mpxgeometryiterator-optional\">MPxGeometryIterator (optional)</h2></div>\n\
<p>This class provides Maya with a control point iterator for your geometry. The iterator queries and sets points in your geometry generically. Iterators are used when your shape has components associated with its attributes.</p>\n\
<div class=\'section\'><a id=\"mpxgeometrydata-optional\"></a><h2 id=\"mpxgeometrydata-optional\">MPxGeometryData (optional)</h2></div>\n\
<p>This class is used to provide Maya with a container for your geometry that can be passed through DG connections. It is often more efficient to pass all of the information about your geometry as data than as separate attributes. If you want your shape to work with Maya’s deformers then you must provide a data class as input and output attributes to your shape.</p>\n\
<div class=\'section\'><a id=\"mtextureeditordrawinfo-optional\"></a><h2 id=\"mtextureeditordrawinfo-optional\">MTextureEditorDrawInfo (optional)</h2></div>\n\
<p>This class is used by the <span class=\'code\'>drawUV</span> method of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShapeUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSurfaceShapeUI</a></span> to specify the current UV drawing state for a user defined shape. API users must override the <span class=\'code\'>canDrawUV</span> method on <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShapeUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_surface_shape_u_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSurfaceShapeUI</a></span> to receive <span class=\'code\'>drawUV</span> calls.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";