var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Troubleshoot GLSL shaders</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Troubleshoot GLSL shaders</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"troubleshoot-glsl-shaders\"></a></div>\n\
<div class=\'section\'><a id=\"problem\"></a><h2 id=\"problem\">Problem</h2></div>\n\
<p>When loading an <span class=\'code\'>.ogsfx</span> shader instance via <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsFileShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a581c659670f0e3168750382c61a91a25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsFileShader()</a></span> or <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsBufferShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#ad99e1c36c00ccaf3ea0c7fe0599557f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsBufferShader()</a></span>, the shader is not rendered in the viewport, and no error appears.</p>\n\
<p>How can I obtain shader compile errors?</p>\n\
<div class=\'section\'><a id=\"solution\"></a><h2 id=\"solution\">Solution</h2></div>\n\
<p>When loading <span class=\'code\'>.ogsfx</span> shaders, errors occur at bind time rather than at creation time when <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsFileShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a581c659670f0e3168750382c61a91a25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsFileShader()</a></span> is called. Call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance.bind()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_instance.html#ad2e3cf28a86c237f76e44c8b4490658a&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance.bind()</a></span> to bind the shader instance to the draw context, then call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a32aa7a2b395ae162d8fc66abf5f5a14a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastError()</a></span> or <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastErrorSource()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a45e7598b79e4e7202aa4082baec16231&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastErrorSource()</a></span> to report the effect compile errors.</p>\n\
<p>Alternatively, you can set the following pragma in the shader so that errors occur at creation time:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#pragma FullCompileOnLoad:true; \n\
</pre></div><p>You must then call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a32aa7a2b395ae162d8fc66abf5f5a14a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastError()</a></span> or <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastErrorSource()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a45e7598b79e4e7202aa4082baec16231&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastErrorSource()</a></span> to report the effect compile errors.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";