var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Shader semantics supported by Viewport 2.0</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Shader semantics supported by Viewport 2.0</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"shader-semantics-supported-by-viewport-2.0\"></a></div>\n\
<p>The following semantics are recognized and supported for use with shaders in Viewport 2.0. They can be used when authoring full effects which are accessed as <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance</a></span> objects using the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager</a></span> class. They may also be applied to the parameters of fragments which are registered using <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFragmentManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_fragment_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_fragment_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFragmentManager</a></span>.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> The <span class=\'code\'>dx11Shader.mll</span> and <span class=\'code\'>glslShader.mll</span> plug-ins are both <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span>s. Therefore, each must parse the effects to determine and bind the semantics manually. By comparison, both the fragment system and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance</a></span> do all this automatically; however, they are both also more restrictive.</p>\n\
</blockquote>\n\
<p>The world co-ordinate system can be further divided into different locales, each with a different origin. A node can then be specified in any of these locales. This allows the node position to be made with greater precision than if it were defined in the world co-ordinate system.</p>\n\
<p>All matrices that belong to the FrameLocale group are re-applied when the locale of a current node is different from the locale of a previous node. At render time, camera and lights are transformed into the current node&#39;s locale space so that the object, the camera, and the lights are all represented in the same local co-ordinate space and can be stored and represented with single precision floating point values.</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\"><colgroup><col width=\"35.714285714285715%\"> <col width=\"35.714285714285715%\"> <col width=\"14.285714285714285%\"> <col width=\"14.285714285714285%\"> </colgroup><tbody><tr class=\"ruled-odd-row\"><td class=\"table-body\"><em class=\"strong\">Semantic</em></td><td class=\"table-body\"><em class=\"strong\">Usage</em></td><td class=\"table-body\"><em class=\"strong\">Type</em></td><td class=\"table-body\"><em class=\"strong\">Group</em></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">World</td><td class=\"table-body\">World transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldTranspose</td><td class=\"table-body\">World transformation, transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldInverse</td><td class=\"table-body\">World transformation, inverted</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldInverseTranspose</td><td class=\"table-body\">World transformation, inverted and transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">PreviousWorld</td><td class=\"table-body\">Previous world transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">Item</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">NextWorld</td><td class=\"table-body\">Next world transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">Item</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">View</td><td class=\"table-body\">View transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">ViewTranspose</td><td class=\"table-body\">View transformation, transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">ViewInverse</td><td class=\"table-body\">View transformation, inverted</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">ViewInverseTranspose</td><td class=\"table-body\">View transformation, inverted and transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">Projection</td><td class=\"table-body\">Projection transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">ProjectionTranspose</td><td class=\"table-body\">Projection transformation, transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">ProjectionInverse</td><td class=\"table-body\">Projection transformation, inverted</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">ProjectionInverseTranspose</td><td class=\"table-body\">Projection transformation, inverted and transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\"><p class=\"table-body\">ProjectionZSense</p></td><td class=\"table-body\">Denotes whether the projection matrix flips the Z component of a point when transformed: if so, -1.0; otherwise 1.0.</td><td class=\"table-body\">Float</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldView</td><td class=\"table-body\">World-view transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldViewTranspose</td><td class=\"table-body\">World-view transformation, transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldViewInverse</td><td class=\"table-body\">World-view transformation, inverted</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldViewInverseTranspose</td><td class=\"table-body\">World-view transformation, inverted and transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\"><a name=\"GUID-33B0F28C-B01C-4686-8FD4-CF880BA501D4\"></a><p class=\"table-body\">WorldLocaleOrigin</p></td><td class=\"table-body\">Apply an offset to the locale transformation matrix to obtain the true (global) world transformation matrix.<a name=\"GUID-C53DAB92-F9B1-4038-931F-571D77084DE3\"></a><p class=\"table-body\">Applying this offset can result in a lack of precision in cases where double precision is required to represent an accurate position in large coordinate systems.</p></td><td class=\"table-body\">Float3</td><td class=\"table-body\"><p class=\"table-body\">FrameLocale</p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">ViewProjection</td><td class=\"table-body\">View-projection transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">ViewProjectionTranspose</td><td class=\"table-body\">View-projection transformation, transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">ViewProjectionInverse</td><td class=\"table-body\">View-projection transformation, inverted</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">ViewProjectionInverseTranspose</td><td class=\"table-body\">View-projection transformation, inverted and transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">PreviousViewProjection</td><td class=\"table-body\">Previous view-projection transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldViewProjection</td><td class=\"table-body\">World-view-projection transformation</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldViewProjectionTranspose</td><td class=\"table-body\">World-view-projection transformation, transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldViewProjectionInverse</td><td class=\"table-body\">World-view-projection transformation, inverted</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldViewProjectionInverseTranspose</td><td class=\"table-body\">World-view-projection transformation, inverted and transposed</td><td class=\"table-body\">Matrix</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\" colspan=\"4\"><p class=\"table-body\">The following are MultiDraw versions of other semantics, used as alternates for rendering MultiDraw consolidation if<span class=\"code\" translate=\"no\"> <a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride::supportsMultiDraw()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html#a74828e53545b3cf4dea69c7cd542cde7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride::supportsMultiDraw()</a></span> is overridden to return true.</p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldMD</td><td class=\"table-body\">MultiDraw array of World transformation</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldTMD</td><td class=\"table-body\">MultiDraw array of World transformation, transposed</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldIMD</td><td class=\"table-body\">MultiDraw array of World transformation, inverted</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldITMD</td><td class=\"table-body\">MultiDraw array of World transformation, inverted and transposed</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldViewMD</td><td class=\"table-body\">MultiDraw array of World-view transformation</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldViewTMD</td><td class=\"table-body\">MultiDraw array of World-view transformation, transposed</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldViewIMD</td><td class=\"table-body\">MultiDraw array of World-view transformation, inverted</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldViewITMD</td><td class=\"table-body\">MultiDraw array of World-view transformation, inverted and transposed</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldViewProjMD</td><td class=\"table-body\">MultiDraw array of World-view-projection transformation</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldViewProjTMD</td><td class=\"table-body\">MultiDraw array of World-view-projection transformation, transposed</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">WorldViewProjIMD</td><td class=\"table-body\">MultiDraw array of World-view-projection transformation, inverted</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">WorldViewProjITMD</td><td class=\"table-body\">MultiDraw array of World-view-projection transformation, inverted and transposed</td><td class=\"table-body\">Matrix[64]</td><td class=\"table-body\"><p class=\"table-body\">Item <sup>FL</sup></p></td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">ViewDirection</td><td class=\"table-body\">World-space direction of the view (camera)</td><td class=\"table-body\">Float3</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">ViewPosition</td><td class=\"table-body\">World-space position of the view (camera)</td><td class=\"table-body\">Float3</td><td class=\"table-body\">FrameLocale</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">LocalViewer</td><td class=\"table-body\">Denotes whether a local or non-local view direction is to be used</td><td class=\"table-body\">Bool</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">IsOrthoGraphic</td><td class=\"table-body\">Denotes whether the projection matrix is orthographic</td><td class=\"table-body\">Bool</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">ViewportPixelSize</td><td class=\"table-body\">Dimensions of the current viewport in pixels, width and height</td><td class=\"table-body\">Float2</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">ClippingPlanes</td><td class=\"table-body\">The coefficients of active clipping planes, one float4 per plane</td><td class=\"table-body\">Float4 Array</td><td class=\"table-body\">Clipping</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">ClippingPlaneCount</td><td class=\"table-body\">The number of active clipping planes</td><td class=\"table-body\">Int</td><td class=\"table-body\">Clipping</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">NearClipPlane</td><td class=\"table-body\">The camera’s near clipping plane</td><td class=\"table-body\">Float</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\"><a name=\"GUID-105B4916-4770-43D6-9B68-2EEEF5C055F2\"></a><p class=\"table-body\">Time</p><a name=\"GUID-CA2C68E6-5104-4461-BB19-ED2F2604E1B7\"></a><p class=\"table-body\">AnimationTime</p><a name=\"GUID-5F6B7AA6-90FF-4EE2-A579-065A42F0382C\"></a><p class=\"table-body\">Sas.Time.Now</p></td><td class=\"table-body\"><a name=\"GUID-F873B1BA-9CFF-4E9D-B7F8-234BF99691EE\"></a><p class=\"table-body\">Time in seconds</p><div><a name=\"GUID-7A527536-0D0E-4191-9BDC-F8FFFFC93331\"></a><div class=\"note-note\"><span class=\"label label-target-language\">Note: </span><p><a name=\"GUID-43BCD405-B2CE-4D2B-BD2B-E4A3B71E8DFF\"></a>Only applicable to shading overrides created using an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span>. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span> must support auto-binding of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUniformParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniformParameter</a></span>s to the shader uniform parameters.</p><p><a name=\"GUID-F5ED1133-AEAD-495F-A76D-36386F9335B8\"></a>That is, the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span> must create an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUniformParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniformParameter</a></span> for each uniform parameter, retrieve each <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUniformParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniformParameter</a></span> value based on its associated semantic, and bind this value to the shader uniform parameter.</p><p><a name=\"GUID-AC42EAAD-20F6-4D86-ABB5-56DB939A6FD7\"></a>This is automatically done by the <span class=\"code\" translate=\"no\">dx11Shader</span> and <span class=\"code\" translate=\"no\">glslShader</span> plug-ins.</p><p><a name=\"GUID-11BD2A4D-C78A-4790-BE30-DF21FE925299\"></a>In addition, Time and Frame are only available when the effects file is loaded from the <span class=\"code\" translate=\"no\">glslShader</span> plug-in.</p></div></div></td><td class=\"table-body\">Float</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\"><a name=\"GUID-15566208-8077-4624-95EE-2572E7D0D01D\"></a><p class=\"table-body\">Frame</p><a name=\"GUID-B561D443-7B30-465C-A887-BD8671B9DFDA\"></a><p class=\"table-body\">FrameNumber</p></td><td class=\"table-body\"><a name=\"GUID-016C3436-E901-4E69-82F7-D0241BFD780B\"></a><p class=\"table-body\">Frame in frame units</p><div><a name=\"GUID-4A1D6F0E-E938-4C54-AA2E-3DD70653F974\"></a><div class=\"note-note\"><span class=\"label label-target-language\">Note: </span><p><a name=\"GUID-3E1E1915-EA98-47DB-86FC-565A01C436F6\"></a>Only applicable to shading overrides created using an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span>. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span> must support auto-binding of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUniformParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniformParameter</a></span>s to the shader uniform parameters.</p><p><a name=\"GUID-918BBA9E-89CF-4A47-A51B-96C46D368944\"></a>That is, the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span> must create an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUniformParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniformParameter</a></span> for each uniform parameter, retrieve each <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUniformParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniformParameter</a></span> value based on its associated semantic, and bind this value to the shader uniform parameter.</p><p><a name=\"GUID-F263A79F-E5FB-460A-BFF6-CEE60230F0E1\"></a>This is automatically done by the <span class=\"code\" translate=\"no\">dx11Shader</span> and <span class=\"code\" translate=\"no\">glslShader</span> plug-ins.</p></div></div></td><td class=\"table-body\">Int</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">AlphaTestFunction</td><td class=\"table-body\">The alpha test comparison function<a name=\"GUID-EE159836-FCD7-461F-BA2D-D7AAB40CCDFF\"></a><p class=\"table-body\">1 = Never</p><a name=\"GUID-95FD92A2-0231-457E-8EB2-17CD9002FB9B\"></a><p class=\"table-body\">2 = Less</p><a name=\"GUID-A7DAF2A6-1B0C-485D-8793-2BBD923DC50B\"></a><p class=\"table-body\">3 = Equal</p><a name=\"GUID-6F3FBB25-9802-45FE-880E-573068AE5A6E\"></a><p class=\"table-body\">4 = Less or Equal</p><a name=\"GUID-9EDDB7C4-D4AF-42EA-9FBF-F7D00DFDFED9\"></a><p class=\"table-body\">5 = Greater</p><a name=\"GUID-1D2866EE-F35F-43E6-856E-1F0B292E583D\"></a><p class=\"table-body\">6 = Not Equal</p><a name=\"GUID-ACA9C7F3-5F04-4325-B2B9-DDCFD2EFE988\"></a><p class=\"table-body\">7 = Greater or Equal</p><a name=\"GUID-8EA6365F-C996-4DDB-8CDE-2D2D06D06339\"></a><p class=\"table-body\">8 = Always</p></td><td class=\"table-body\">Int</td><td class=\"table-body\">Alpha Test</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">AlphaTestReference</td><td class=\"table-body\">The alpha test reference value, in the range of (0.0, 1.0)</td><td class=\"table-body\">Float</td><td class=\"table-body\">Alpha Test</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">RelativeViewportDimensions</td><td class=\"table-body\">Specifies relative viewport dimensions</td><td class=\"table-body\">Float2</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">MayaReceivesShadowOn</td><td class=\"table-body\">Denotes whether the object receives shadows</td><td class=\"table-body\">Bool</td><td class=\"table-body\">Item</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">EnableXRayComp</td><td class=\"table-body\">Denotes whether xray component mode is enabled</td><td class=\"table-body\">Bool</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">MayaViewportModes</td><td class=\"table-body\">Viewport modes<a name=\"GUID-14E5AA82-FCDB-49E7-970D-1BCB5B4BBE88\"></a><p class=\"table-body\">0 = Does not contain bounding box</p><a name=\"GUID-70D3C9DE-99F4-4F92-8BBB-97530384DDA5\"></a><p class=\"table-body\">1 = Contains bounding box</p></td><td class=\"table-body\">Int</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td><td class=\"table-body\">&nbsp;</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">FogEnabled</td><td class=\"table-body\">Denotes whether hardware fog is enabled</td><td class=\"table-body\">Bool</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">FogMode</td><td class=\"table-body\">Hardware fog falloff mode<a name=\"GUID-2087A985-C505-4130-8D04-BFE0D8AEC1F7\"></a><p class=\"table-body\">0 = Linear</p><a name=\"GUID-6F568841-FDA5-4D84-BE55-C8E2494D794B\"></a><p class=\"table-body\">1 = Exponential</p><a name=\"GUID-6404C7B5-AAED-4B52-BA30-81473C88DB54\"></a><p class=\"table-body\">2 = Exponential-squared</p></td><td class=\"table-body\">Int</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">FogStart</td><td class=\"table-body\">Hardware fog start z-distance in view space</td><td class=\"table-body\">Float</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">FogEnd</td><td class=\"table-body\">Hardware fog end z-distance in view space</td><td class=\"table-body\">Float</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-even-row\"><td class=\"table-body\">FogDensity</td><td class=\"table-body\">Hardware fog density</td><td class=\"table-body\">Float</td><td class=\"table-body\">Frame</td></tr><tr class=\"ruled-odd-row\"><td class=\"table-body\">FogColor</td><td class=\"table-body\">Hardware fog color</td><td class=\"table-body\">Float4</td><td class=\"table-body\">Frame</td></tr></tbody></table>\n\
<blockquote>\n\
<p><strong>Note:</strong> FL denotes that the semantic is also frame locale dependant.</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";