var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>What&#39;s New in API in Maya 2016 Extension 2</title>\n\
   <meta name=\"contextid\" content=\"WHATS_NEW_API_2016EXT2\"><meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>What&#39;s New in API in Maya 2016 Extension 2</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"whats-new-in-api-in-maya-2016-extension-2\"></a></div>\n\
<div class=\'section\'><a id=\"maya-viewport-2.0-whitepaper\"></a><h2 id=\"maya-viewport-2.0-whitepaper\">Maya Viewport 2.0 whitepaper</h2></div>\n\
<p>The Maya Viewport 2.0 whitepaper can be found at <a href=\'http://www.autodesk.com/developmaya\' title=\'\' target=\'_blank\'>http://www.autodesk.com/developmaya</a>.</p>\n\
<p>This document is divided into two parts. The first (<em>Viewport 2.0 API Porting Guide</em>) is an overview of Viewport 2.0 and outlines the differences between the legacy default viewport and Viewport 2.0. The second part (<em>Viewport 2.0 API Porting Guide Details</em>) is more detailed and specifies the recommended interfaces and provides code examples for common tasks.</p>\n\
<div class=\'section\'><a id=\"maya-animation-performance-whitepaper\"></a><h2 id=\"maya-animation-performance-whitepaper\">Maya animation performance whitepaper</h2></div>\n\
<p>The <em>Improving Performance with Parallel Evaluation</em> whitepaper can be found at <a href=\'http://www.autodesk.com/maya-docs\' title=\'\' target=\'_blank\'>http://www.autodesk.com/maya-docs</a>.</p>\n\
<p>Refer to this document for information on how to use the new Evaluation Manager feature to improve playback and manipulation of your animated scenes through scene-level graph analysis and parallelization. In addition, it provides information on the API extensions that your plug-in can implement to take advantage of these features, as well as guidelines on how to use the Profiler to evaluate performance in your scene.</p>\n\
<div class=\'section\'><a id=\"api-compatibility\"></a><h2 id=\"api-compatibility\">API compatibility</h2></div>\n\
<p>Maya 2016 Extension 2 is not binary compatible with Maya 2016.</p>\n\
<p>C++ plug-ins that were compiled against Maya 2016 or Maya 2016 Extension 1, including Maya 2016 service pack releases, must be re-compiled against Maya 2016 Extension 2 in order to be recognized by this version of Maya.</p>\n\
<p>In addition, plug-ins compiled against Maya 2016 Extension 2 will either not load or exhibit unpredictable behavior if loaded in Maya 2016, Maya 2016 Extension 1, or any Maya 2016 service pack release.</p>\n\
<p>To obtain the Maya 2016 and Maya 2016 Extension 1 API Guide, see <a href=\'http://www.autodesk.com/me-sdk-docs-2016\' title=\'\' target=\'_blank\'>http://www.autodesk.com/me-sdk-docs-2016</a>.</p>\n\
<div class=\'section\'><a id=\"location-of-c-api-header-files-and-libraries\"></a><h2 id=\"location-of-c-api-header-files-and-libraries\">Location of C++ API header files and libraries</h2></div>\n\
<p>The C++ API header files and libraries are now available with the Maya installation. It is no longer necessary to download the Maya Developer Kit in order to compile your custom plug-ins. The header and library files can be found in the following folders of your Maya installation:</p>\n\
<p>Windows and Linux:</p>\n\
<ul>\n\
<li>Header files: <span class=\'code\'>../include/maya</span></li>\n\
<li>Libraries: <span class=\'code\'>../lib</span></li>\n\
</ul>\n\
<p>Mac OS X:</p>\n\
<ul>\n\
<li>Header files: <span class=\'code\'>../include/maya</span></li>\n\
<li>Libraries: <span class=\'code\'>../Maya.app/Contents/MacOS</span></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"maya-developer-kit\"></a><h2 id=\"maya-developer-kit\">Maya Developer Kit</h2></div>\n\
<p>The Developer Kit is available online at Autodesk Exchange at <a href=\'https://apps.exchange.autodesk.com/MAYA/en/Home/Index\' title=\'\' target=\'_blank\'>https://apps.exchange.autodesk.com/MAYA/en/Home/Index</a>.</p>\n\
<div class=\'section\'><a id=\"register-node-id-block-and-tangent-types-id-block\"></a><h2 id=\"register-node-id-block-and-tangent-types-id-block\">Register Node ID block and Tangent Types ID block</h2></div>\n\
<p>You can now register a Maya Node ID block or a Tangent Types ID block at <a href=\'http://mayaid.autodesk.io/\' title=\'\' target=\'_blank\'>http://mayaid.autodesk.io/</a>. See also the <em>Tools &amp; Documentation archives</em> section at <a href=\'http://www.autodesk.com/developmaya\' title=\'\' target=\'_blank\'>http://www.autodesk.com/developmaya</a> for more information.</p>\n\
<p>Jump to the following sections:</p>\n\
<ul>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#python-api-2-0\' title=\'\'>Python API 2.0</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#rendering\' title=\'\'>Rendering</a>\n\
<ul>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#selection\' title=\'\'>Selection</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#drawing\' title=\'\'>Drawing</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#shaders\' title=\'\'>Shaders</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#textures\' title=\'\'>Textures</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#lighting\' title=\'\'>Lighting</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#geometry\' title=\'\'>Geometry</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#locators\' title=\'\'>Locators</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#cameras\' title=\'\'>Cameras</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#render-overrides\' title=\'\'>Render overrides</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#tools-and-context\' title=\'\'>Tools and context</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#tracing-sequencing\' title=\'\'>Tracking/sequencing</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#profiling\' title=\'\'>Profiling</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#performance-improvements-for-viewport-2-0-api-plug-ins\' title=\'\'>Performance improvements for Viewport 2.0 API plug-ins</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#documentation-updates\' title=\'\'>Documentation updates</a></li>\n\
</ul></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#animation\' title=\'\'>Animation</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#modeling\' title=\'\'>Modeling</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#user-interface\' title=\'\'>User interface</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#general\' title=\'\'>General</a></li>\n\
<li><a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#effects-and-painting\' title=\'\'>Effects and painting</a></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"python-api-2.0\"></a><h2 id=\"python-api-2.0\">Python API 2.0</h2></div>\n\
<p>The following classes and methods have been added to Python API 2.0:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MURI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_u_r_i.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_u_r_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MURI</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_set.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_set.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnSet</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnContainerNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_container_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_container_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnContainerNode</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnReference\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_reference.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_reference.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnReference</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVaryingParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_varying_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_varying_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVaryingParameter</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUniformParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_uniform_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniformParameter</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTextureAssignment\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/struct_m_h_w_render_1_1_m_texture_assignment.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_texture_assignment.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTextureAssignment</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderTargetAssignment\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/struct_m_h_w_render_1_1_m_render_target_assignment.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target_assignment.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderTargetAssignment</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderProfile\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_render_profile.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_profile.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderProfile</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxHardwareShader\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hardware_shader.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_hardware_shader.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxHardwareShader</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ShaderContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/struct_m_px_hardware_shader_1_1_shader_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_shader_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ShaderContext</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDragAndDropBehavior\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_drag_and_drop_behavior.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_drag_and_drop_behavior.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDragAndDropBehavior</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.registerDragAndDropBehavior()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#a53c50b16274c6e96f192408c9fbbfd2c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin.registerDragAndDropBehavior()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.deregisterDragAndDropBehavior()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#a5cabd62870b3e6a456c5c8eb1484aa1a&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin.deregisterDragAndDropBehavior()</a></span></li>\n\
<li><p>Iteration classes as follows:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dag.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItDag</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIteratorType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_iterator_type.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_iterator_type.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIteratorType</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDependencyNodes\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dependency_nodes.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dependency_nodes.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItDependencyNodes</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDependencyGraph\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dependency_graph.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dependency_graph.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItDependencyGraph</a></span></li>\n\
</ul>\n\
<p>A Python API 2.0 version of the example has been added to <a href=\'#!/url=./developer/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Example-Creating-a-Scene.html\' title=\'\'>Example: Creating a Scene</a>, and the Python API 2.0 example on <a href=\'#!/url=./developer/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Querying-the-Scene-Graph.html\' title=\'\'>Querying the Scene Graph</a> updated as a result.</p></li>\n\
<li>Interfaces added for shading:\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem</a></span>.<span class=\'code\'>OverrideNonMaterialItem</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride.nonTexturedShaderInstance()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html#a4a0a491142830a1b163d4928d5b1638b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride.nonTexturedShaderInstance()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride.overridesNonMaterialItems()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html#aa726094110d2476e166afb3200f07a7e&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride.overridesNonMaterialItems()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager.getLastError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#ae0051d8ad53d1231615f3a1ae93d9785&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager.getLastError()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager.getLastErrorSource()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#a942bb797f95fd59e54fa664f9a0eabf3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager.getLastErrorSource()</a></span></li>\n\
</ul></li>\n\
<li>Interfaces added for render overrides:\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MClearOperation.setOverridesColors()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_clear_operation.html#a3a1fd36973f6c92728ee81147e0e9d44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MClearOperation.setOverridesColors()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MClearOperation.overridesColors()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_clear_operation.html#a83ae0ab940a783456d7d4270932a1fad&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MClearOperation.overridesColors()</a></span></li>\n\
</ul></li>\n\
<li><p>Interfaces added for component selection:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPassContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_pass_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_pass_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPassContext</a></span>.<span class=\'code\'>kSelectionPassSemantic</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride.refineSelectionPath()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html#ae8c468cb28398ef258c29fe4ecefe72c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride.refineSelectionPath()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride.updateSelectionGranularity()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html#a77de49852a7f2bcc4aec146bdcbe327c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride.updateSelectionGranularity()</a></span></li>\n\
</ul>\n\
<p>Added <em>pyApiMeshShape</em> developer kit example to illustrate component selection.</p>\n\
<p>Python examples are available in the <span class=\'code\'>plug-ins\\scripted</span> directory of the Maya Developer Kit.</p></li>\n\
<li><p>The following classes can now be initialized with sequences of compatible elements:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPointArray</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVectorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVectorArray</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MMatrixArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_matrix_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrixArray</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPointArray</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVectorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVectorArray</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTimeArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_time_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_time_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTimeArray</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MColorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_color_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_color_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MColorArray</a></span></li>\n\
</ul>\n\
<p>For example, you can now create an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPointArray</a></span> with a sequence of sequences (including lists and tuples), without the need to first create an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a></span> for each sequence.</p>\n\
<p>In other words, you can now do the following:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">pySeq = [[1,2,3],[4,5,6]]\n\
a = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMaya.MPointArray</a>(pySeq)\n\
</pre></div><p>instead of having to do the following:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">a = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMaya.MPointArray</a>([<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMaya.MPoint</a>(i) for i in pySeq])\n\
</pre></div><p>You can also do the following:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">adaptList = [\n\
              (-3.787, 0.05, 2),\n\
              [189.3, 4.0, 4.01],\n\
              om.MFloatPoint(0.0002, 16.35, -8.9),\n\
              om.MVector(1, 2, 3),\n\
              om.MPoint(-6.314, 2.09, 17.8)\n\
              ]\n\
fpa = om.MFloatPointArray(adaptList)\n\
pa = om.MPointArray(fpa)\n\
ta = om.MTimeArray([0,4,8,15,17])</pre></div></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh.create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html#a3571e84c33d2411e2909e1c6108e27f7&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh.create()</a></span> now returns the newly created mesh.</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode.name()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#af35e9a723ae6ca48453e7dbe4d1029b8&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode.name()</a></span> is now available for Python API 2.0.</li>\n\
<li>New methods for undo and redo:\n\
<ul>\n\
<li>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal.isUndoing()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a963921eebbe9d84ad4d8800288b3c9d0&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal.isUndoing()</a></span> method that returns true if Maya is currently performing an undo.</li>\n\
<li>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal.isRedoing()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a7dd9971a6f456bee9956a3e2b22bd131&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal.isRedoing()</a></span> method that returns true if Maya is currently performing a redo.</li>\n\
</ul></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"rendering\"></a><h2 id=\"rendering\">Rendering</h2></div>\n\
<div class=\'section\'><a id=\"openmayarender\"></a><h3 id=\"openmayarender\">OpenMayaRender</h3></div>\n\
<div class=\'section\'><a id=\"selection\"></a><h4 id=\"selection\">Selection</h4></div>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSubSceneOverride::getInstancedSelectionPath()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_sub_scene_override.html#a3d9b68da81d724902522fe2bf5f809c5&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSubSceneOverride::getInstancedSelectionPath()</a></span> has been added that enables you to select the correct render item instance when the viewport is in GPU acceleration mode. See the <em>gpuCache</em> example in the Maya Developer Kit for more information.</li>\n\
<li><p>A <span class=\'code\'>handlesConsolidatedGeometry</span> semantic has been added that, when set to False, specifies that the Consolidate World feature should be disabled on the geometry to which the glslShader is applied.</p>\n\
<p>See <a href=\'#!/url=./developer/Viewport-2-0-API/Semantics-and-annotations.html\' title=\'\'>Semantics and annotations supported by the dx11Shader and glslShader plug-ins in Viewport 2.0</a> and <a href=\'#!/url=./developer/Viewport-2-0-API/Shader-semantics-supported-by.html\' title=\'\'>Shader semantics supported by Viewport 2.0</a>.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"drawing\"></a><h4 id=\"drawing\">Drawing</h4></div>\n\
<p>M3dView</p>\n\
<ul>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"M3dView::readDepthMap()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html#a9dd85add630aeee817d42c1018261fa8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">M3dView::readDepthMap()</a></span> can now be used with Viewport 2.0, and allows you to read depth values directly from the depth map of Viewport 2.0.</p>\n\
<p>See the <em>pointManip</em> developer kit example. When dragging the pointManip, the selected objects are moved to the closest intersection point between the mouse ray and opaque objects, which is calculated from the screen-space position and the corresponding depth value.</p></li>\n\
</ul>\n\
<p>MDrawContext</p>\n\
<ul>\n\
<li><p>The update frequency of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::getFrameStamp()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#ac9d36cff81e99e1fb66d9e162b97ecfb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawContext::getFrameStamp()</a></span> has been modified to update the stamp less frequently within a single frame.</p>\n\
<p>See the <em>rawfootPrintNode</em> and<em>glslShader</em> plug-in examples for usage of <span class=\'code\'>getFrameStamp()</span>.</p></li>\n\
</ul>\n\
<p>MFrameContext</p>\n\
<ul>\n\
<li><p>Added new method <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::getEnvironmentParameters()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a808eb19b78c4361cc6105ed7ff7c8c0d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::getEnvironmentParameters()</a></span>.</p>\n\
<p>This method returns the environment parameters set for the current viewport. Can be used in the draw phase for a plug-in hardware shader to check if an environment map is set for the current viewport (the method is accessed on the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawContext</a></span> given to the shader). If an environment is enabled, the path to the environment image file is given. The image is always in latlong format. Note that this information is set per viewport and therefore may change between successive draw calls if multiple viewports are displayed at the same time.</p>\n\
<p>Currently, environments are only used by the Material Viewer in the Hypershade. For all other viewports, the environment is always set to disabled.</p></li>\n\
<li><p>Added object type exclusion statics to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext</a></span>.</p>\n\
<p>Note that a <span class=\'code\'>MUint64</span> value is returned to allow for a complete set of exclusions to be accessed.</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">MUint64 objectTypeExclusions() const;\n\
</pre></div><p>Exclusion by classification string has been newly added:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void classificationExclusions(<a href=\"javascript:void(0)\" data-symbol=\"MStringArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStringArray</a> &amp;classification) const;\n\
</pre></div><p>The statics on <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext</a></span> should be instead of the enum <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender::MObjectTypeExclusions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html#abe19e9c85c46e56786772492a4ce62eb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender::MObjectTypeExclusions</a></span>, which has a subset of the new enum list.</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender::getObjectTypeExclusions()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html#a2abb399fe36f33b0fc3b223cc3174edd&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender::getObjectTypeExclusions()</a></span> has been added to return a <span class=\'code\'>MUint64</span> type. The <span class=\'code\'>objectTypeExclusions()</span> method that returns <span class=\'code\'>MObjectTypeExclusions</span> is considered to be obsolete, but will still work unless <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender::getObjectTypeExclusions()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html#a2abb399fe36f33b0fc3b223cc3174edd&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender::getObjectTypeExclusions()</a></span> is overridden.</p>\n\
<p>The <em>viewImageBlitOverride</em> and <em>pyViewRenderOverride.py</em> plug-in examples have been updated to use the new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext</a></span> statics.</p></li>\n\
<li><p>A number of additions have been made to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext</a></span> to enable querying of state information without having to access <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"M3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">M3dView</a></span>. These include:</p>\n\
<ul>\n\
<li>Additional display styles (enum <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::DisplayStyle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a1b68f8823b8e275a4b548fdd27263e8a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::DisplayStyle</a></span>) : shaded active objects (<span class=\'code\'>kShadeActiveOnly</span>), x-ray active components (<span class=\'code\'>kXrayActiveComponents</span>), backface culling enabled (<span class=\'code\'>kBackfaceCulling</span>), and smooth wireframe (<span class=\'code\'>kSmoothWireframe</span>).</li>\n\
<li>Additional object exclusion types, including: plug-in shapes (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::kExcludePluginShapes\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#ad7bdabe5ece97e23d82287005e91e2fb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::kExcludePluginShapes</a></span>), heads up display (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::kExcludeHUD\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a19e5b2fee997e6804502d1e45887530c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::kExcludeHUD</a></span>), animation clip ghosts (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::kExcludeClipGhosts\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a832f6df0d8de787303036322a9d140dc&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::kExcludeClipGhosts</a></span>), and grease pencil draw items (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::kExcludeGreasePencils\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a11ec30d814c696a5c4c3565b7a2fe52d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::kExcludeGreasePencils</a></span>).</li>\n\
<li>Querying of background color / gradient (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::getBackgroundParameters()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a884cc89835076a7b836b86538c01e722&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::getBackgroundParameters()</a></span>)</li>\n\
<li>Querying of parameters used for the depth of field pass (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::getDOFParameters()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#adc3c931b5b8b55549af38d1b3288ed91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::getDOFParameters()</a></span>)</li>\n\
<li>Querying of render override name (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::getRenderOverrideInformation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#aed7789770ef0eb47fd196edfc669d8f6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::getRenderOverrideInformation()</a></span>)</li>\n\
</ul>\n\
<p>The example plug-in <em>rawfootPrintNode</em> in the Maya Developer Kit has been modified to include debugging code to perform these queries.</p></li>\n\
<li><p>Added <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::worldToViewport()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af45610f0e3a84029c4dfa9a1a0790aea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::worldToViewport()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::viewportToWorld()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a0f5a55195c724b06707730d7d52d915c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::viewportToWorld()</a></span> methods that convert co-ordinates.</p>\n\
<p>This method converts the co-ordinates in world space to co-ordinates in the viewport:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void worldToViewport(const <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp;inPoint, double &amp;xPos, double &amp;yPos) const;\n\
</pre></div><p>This method converts co-ordinates in the viewport to the near clipping plane co-ordinates in world space:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void viewportToWorld(double xPos, double yPos, <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp;worldNearPt, <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp;worldFarPt) const;\n\
</pre></div><p>The example plug-in <em>uiDrawManager</em> demonstrates the use of these methods when drawing 2d text and 3d text.</p></li>\n\
</ul>\n\
<p>MPassContext</p>\n\
<ul>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPassContext::shaderOverrideInstance()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_pass_context.html#aef8d7620ddd58e44e45ea0f0dfaa6fb4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPassContext::shaderOverrideInstance()</a></span> has been added that returns the shader instance for the current shader override. It allows you to use the shader program and parameters that Maya normally uses when drawing.</p>\n\
<p>See the <em>rawFootPrintnode</em> example plug-in in the Developer Kit for more information.</p></li>\n\
</ul>\n\
<p>MPxPrimitiveGenerator and MRenderItem</p>\n\
<ul>\n\
<li><p>The following primitive types are now supported in Viewport 2.0:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometry::kAdjacentLines\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1ea879759a1444d8dc1f7bb0e9ce3d7fafe&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGeometry::kAdjacentLines</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometry::kAdjacentLineStrip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1eac8b498ac7de65dc4ea547cf3216ca4f9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGeometry::kAdjacentLineStrip</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometry::kAdjacentTriangles\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1ea8f0eb61b069ef24cc331fb6e731725a3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGeometry::kAdjacentTriangles</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometry::kAdjacentTriangleStrip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1eae781e3372c3e048088e1000ad04b95c2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGeometry::kAdjacentTriangleStrip</a></span></li>\n\
</ul>\n\
<p>These primitive types can now be used everywhere that a primitive is set in Viewport 2.0, including a new triangle adjacency <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxPrimitiveGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxPrimitiveGenerator</a></span> in the GLSL shader plug-in (see <span class=\'code\'>adjacentTrianglesPrimitiveGenerator.cpp</span> in the <span class=\'code\'>glslShader</span> plug-in folder in the Developer Kit). Refer to <span class=\'code\'>SilhouetteEdge.ogsfx</span> for an example of how this new generator enables the drawing of silhouette edges (see the <span class=\'code\'>presets\\GLSL\\examples</span> folder of the Maya installation directory).</p></li>\n\
</ul>\n\
<p>MPxDrawOverride</p>\n\
<ul>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride::isTransparent()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html#a9af8d1d3490a3fa7779927df11c7c039&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride::isTransparent()</a></span> has been added to indicate that the object needs to be drawn as transparent.</p>\n\
<p>If <span class=\'code\'>/isTransparent</span> is added to the geometry classification <span class=\'code\'>drawdb/geometry/myNode/isTransparent/</span>, then the plug-in will be called during transparent passes.</p>\n\
<p>You must consider post effects also. The classification <span class=\'code\'>drawdb/geometry/includePostEffects/</span> ensures that post effects are called for your draw override. To ensure that both <span class=\'code\'>isTransparent</span> and <span class=\'code\'>includePostEffects</span> take effect, set the classification as <span class=\'code\'>drawdb/geometry/rawfootPrint/isTransparent/includePostEffects</span>.</p>\n\
<p>See the <em>rawfootPrintNode</em> plug-in example.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"post-effects-enhancements\"></a><h4 id=\"post-effects-enhancements\">Post effects enhancements</h4></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride</a></span> can opt-in to being called from post-effects passes by specifying a classification of <span class=\'code\'>drawdb/geometry/includePostEffects</span>. By default, draw overrides are not called for additional post-effect passes such as: depth-of-field, screen space ambient occlusion, and motion-blur.</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride::excludedFromPostEffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html#aa52a15409b28536993452344135ebe89&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride::excludedFromPostEffects()</a></span> can be used to exclude a draw override from being called for post-effects passes. See the <em>rawfootPrintNode</em> plug-in example.</p>\n\
<p>Note: The use of the method <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride::excludedFromPostEffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html#aa52a15409b28536993452344135ebe89&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride::excludedFromPostEffects()</a></span> is preferable to the use of the classification string.</p>\n\
<p>New pass semantics have been added to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPassContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_pass_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_pass_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPassContext</a></span> - <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPassContext::kDOFPassSemantic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_pass_context.html#a730755c181d1c16d7abde72c447fac04&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPassContext::kDOFPassSemantic</a></span>, and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPassContext::kMotionVectorPassSemantic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_pass_context.html#a2781bebea5ef7c30f94bda5bf9c38a36&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPassContext::kMotionVectorPassSemantic</a></span>. These are equivalent to checking for the strings <span class=\'code\'>dofPass</span> and <span class=\'code\'>motionVectorPass</span> in previous releases. <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPassContext::kPEPatternPassSemantic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_pass_context.html#a21eddbaf1720cec960972c79d2cde72a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPassContext::kPEPatternPassSemantic</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPassContext::kNonPEPatternPassSemantic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_pass_context.html#a8f503e129a06c3b3e69d38572579cf63&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPassContext::kNonPEPatternPassSemantic</a></span> have been added to indicate a post effect pattern pass and a non post effect pattern pass, respectively.</p>\n\
<p>The <span class=\'code\'>ProjectionZSense</span> semantic has been added that denotes whether the projection matrix flips the Z component of a point when transformed: if so, its value is -1.0; otherwise 1.0. See <a href=\'#!/url=./developer/Viewport-2-0-API/Shader-semantics-supported-by.html\' title=\'\'>Shader semantics supported by Viewport 2.0</a>.</p>\n\
<p>For more information regarding these passes, see <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Effects-interfaces.html\' title=\'\'>Effects interfaces</a>.</p>\n\
<div class=\'section\'><a id=\"shaders\"></a><h4 id=\"shaders\">Shaders</h4></div>\n\
<p>MShaderInstance</p>\n\
<ul>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance::requiredVertexBuffers()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html#a6e71839b449651e57915ff2f04358a3e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance::requiredVertexBuffers()</a></span> method allows you to query a list of vertex buffer descriptors for a given shader instance (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptorList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVertexBufferDescriptorList</a></span>).</p>\n\
<p>Subscene overrides, in particular, can make use of this method when using shader instances for custom render items, although this method can be called outside of the context of this override.</p>\n\
<p>This method is used in the GLSL shader plug-in. Refer to <em>glslShader</em> in the developer kit. See <span class=\'code\'>configureGeometryRequirements()</span> on the <span class=\'code\'>GLSLShaderNode</span> class where the results are examined to configure <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVaryingParameter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_varying_parameter.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_varying_parameter.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVaryingParameter</a></span>s.</p></li>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getShaderFromNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a1641a382992fc5d6d53adee71d500cf9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getShaderFromNode()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setShaderFromNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a1f821e0772346c0567396a67bb5fee7b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::setShaderFromNode()</a></span> interfaces have a new boolean argument <span class=\'code\'>nonTextured</span> added that allows users to use a non-textured effect instance.</p>\n\
<p>See <em>MPxPrimitiveGenerator and MRenderItem</em> in the <a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#drawing\' title=\'\'>Drawing</a> section above.</p></li>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance::techniqueNames()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html#a687f4a2b433b6926b93b8fe2c5677478&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance::techniqueNames()</a></span> method has been added that returns the list of techniques from a shader instance. This method is also available in Python API 2.0.</p>\n\
<p>A similar method <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsTechniques()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a67d96162d64617bc3299f75cd7c13dff&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsTechniques()</a></span> currently exists that loads an effects file and extracts the names of the defined techniques. However, this function can only be used when loading effects from files and cannot be used when loading effects from string buffers. You can now use the new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance::techniqueNames()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html#a687f4a2b433b6926b93b8fe2c5677478&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance::techniqueNames()</a></span> once the effect is loaded.</p></li>\n\
</ul>\n\
<p>MShaderManager</p>\n\
<ul>\n\
<li><p>When acquiring a shader via any one of the various interfaces on <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager</a></span>, such as <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsFileShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a581c659670f0e3168750382c61a91a25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsFileShader()</a></span> or <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsBufferShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#ad99e1c36c00ccaf3ea0c7fe0599557f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsBufferShader()</a></span>, if a shader compilation failure occurs, then errors will be output to the Output Window on Windows and Linux, and to the console on Mac. This aids in the debugging process for shader writers.</p>\n\
<p>When a shader cannot be returned, a NULL value will be returned.</p>\n\
<p>In particular, this is now true if the string buffer method <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsBufferShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#ad99e1c36c00ccaf3ea0c7fe0599557f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsBufferShader()</a></span> is used. Previously, an error shader was returned, making it difficult to recognize if a failure had occurred.</p></li>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setShaderFromNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a1f821e0772346c0567396a67bb5fee7b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::setShaderFromNode()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getShaderFromNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a1641a382992fc5d6d53adee71d500cf9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getShaderFromNode()</a></span> interfaces have a new boolean argument <span class=\'code\'>nonTextured</span> added that allows users to use a non-textured effect instance.</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setShaderFromNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a1f821e0772346c0567396a67bb5fee7b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::setShaderFromNode()</a></span> is the recommended interface because it does not expose internal effect instances. Its use is demonstrated in the <em>apiMeshShape</em> plug-in example (<span class=\'code\'>apiMeshSubSceneOverride.cpp</span>) in the Developer Kit.</p>\n\
<p>Previously, this sample plug-in created only one render item for both its shaded mode and textured mode. In the new version, two render items are created: one for shaded mode, the other for the textured mode. Their effect instances are both assigned with <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setShaderFromNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a1f821e0772346c0567396a67bb5fee7b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::setShaderFromNode()</a></span>, but the boolean argument <span class=\'code\'>nonTextured</span> is set true for the shaded render item and false for the textured one.</p></li>\n\
</ul>\n\
<p>MPxShaderOverride</p>\n\
<ul>\n\
<li><p>Viewport 2.0 does not, by default, return completely unshared data. A new interface has been added to specify this requirement:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">bool MPxShaderOverride::requiresUnsharedGeometricStreams()\n\
</pre></div><p>A plug-in can override this method to return true in order to force geometric streams to be expanded.</p></li>\n\
<li><p>To request face ids, vertex ids, and local UV coordinates when updating the geometry requirements for the shading effect, the following semantics are now supported. See <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride::addGeometryRequirement()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html#a1293e58405a12d8024512b733e2396d1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride::addGeometryRequirement()</a></span> for more information:</p>\n\
<ul>\n\
<li><span class=\'code\'>vertexid</span> : When set, will return a vertex id buffer</li>\n\
<li><span class=\'code\'>faceid</span> : When set, will return a face id buffer</li>\n\
<li><span class=\'code\'>uvcoord</span>: When set, will return local UV coordinates</li>\n\
</ul>\n\
<p>Note:</p>\n\
<p>See <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Geometry-remapping-for-hardware.html\' title=\'\'>Geometry remapping for hardware rendering</a>.</p></li>\n\
<li><p>The <em>hwPhongShader</em> plug-in example in the Developer Kit demonstrates the following:</p>\n\
<ul>\n\
<li>Set the environment variable MAYA_HWPHONG_TEST_VERTEXID_AND_FACEID to any value, and this example will print the vertex ids and the face ids to the output window for both the Legacy Default Viewport and Viewport 2.0.</li>\n\
<li>Set the environment variable MAYA_HWPHONG_TEST_LOCALUVCOORD to any value, and this example will print the local UV coordinates to the output window for the Legacy Default Viewport and Viewport 2.0.</li>\n\
<li>Set the environment variable MAYA_HWPHONG_TEST_INDEXING to any value, and the index that accesses the id and UV coordinates will print out the local triangle indexing to the output window for both the Legacy Default Viewport and Viewport 2.0.</li>\n\
<li>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride::requiresUnsharedGeometricStreams()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html#a64b871ddc6c792f6c11eb6d46129d9ac&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride::requiresUnsharedGeometricStreams()</a></span> method is overridden to return true for <em>hwPhongShaderOverride</em>.</li>\n\
<li>The <span class=\'code\'>initialize()</span> method of <em>hwPhongShaderOverride</em> specifies extra stream requirements: <span class=\'code\'>vertexid</span>, <span class=\'code\'>faceid</span> and <span class=\'code\'>uvcoord</span>.</li>\n\
<li>The <span class=\'code\'>draw()</span> method of <em>hwPhongShaderOverride</em> extracts the <span class=\'code\'>vertexid</span>, <span class=\'code\'>faceid</span>, and <span class=\'code\'>uvcoord</span> vertex buffers and prints their data.</li>\n\
</ul>\n\
<p>Note:</p>\n\
<p>See also the <em>animCubeNode</em> example, which, when the MAYA_TEST_VERTEXID_AND_FACEID environment variable is set, produces a cube the topology of which changes every 4 frames. When the <em>hwPhongShader</em> is assigned to this shape, the shader receives vertex ids and face ids that are generated from the <em>animCubeNode</em> plug-in.</p></li>\n\
</ul>\n\
<p>MPxHwShaderNode</p>\n\
<ul>\n\
<li><p>The Legacy Default Viewport, by default, returns unshared data.</p>\n\
<p>Previously, vertex ids could be queried using the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideVertexIDs()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#ac8569dc0556726f17320788563f034c6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxHwShaderNode::provideVertexIDs()</a></span> method. Face ids can now be queried using the new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideFaceIDs()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#afa61effad561b9564e161fe930bd038c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxHwShaderNode::provideFaceIDs()</a></span> method. Local UV coordinates can now be queried using the new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideLocalUVCoord()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#a276892ea9def000206de6522deccc137&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxHwShaderNode::provideLocalUVCoord()</a></span> method.</p>\n\
<p>There are new methods that return the data with this signature:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a>    <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::geometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#acd6773ef64b27965c09ed584830bf8f3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxHwShaderNode::geometry</a>( const <a href=\"javascript:void(0)\" data-symbol=\"MDrawRequest\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_request.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawRequest</a>&amp; request,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"M3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">M3dView</a>&amp; view,\n\
        int prim,\n\
        unsigned int writable,\n\
        int indexCount,\n\
        const unsigned int * indexArray,\n\
        int vertexCount,\n\
        const int * vertexIDs,\n\
        const float * vertexArray,\n\
        int normalCount,\n\
        const float ** normalArrays,\n\
        int colorCount,\n\
        const float ** colorArrays,\n\
        int texCoordCount,\n\
        const float ** texCoordArrays,\n\
        const int *faceIDs,\n\
        const float * localUVCoord)\n\
Mstatus <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::glGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#a495a60eaa1df3815d5565e79e08c90ac&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxHwShaderNode::glGeometry</a>( const <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a>&amp; shapePath,\n\
        int prim,\n\
        unsigned int writable,\n\
        int indexCount,\n\
        const unsigned int * indexArray,\n\
        int vertexCount,\n\
        const int * vertexIDs,\n\
        const float* vertexArray,\n\
        int normalCount,\n\
        floatArrayPtr normalArrays,\n\
        int colorCount,\n\
        floatArrayPtr colorArrays,\n\
        int texCoordCount,\n\
        floatArrayPtr texCoordArrays,\n\
        const int * faceIDs,\n\
        const float * localUVCoord)\n\
</pre></div><p>The <em>blindDataShader</em> and <em>hwPhongShader</em> plug-in examples both demonstrate the use of this interface to retrieve vertex and face ids.</p>\n\
<p>The <em>blindDataShader</em> example displays a grey-scale value for the corresponding face ids returned.</p>\n\
<p>Note that the UV co-ordinates, face and vertex ids returned will be equivalent for both the Viewport 1 and Viewport 2.0 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span> interface (provided that the Viewport 2.0 interface asks for unshared data).</p>\n\
<p>When a mesh is using smooth mesh preview, then the face ids returned are those of the original unsmoothed mesh while the vertex ids are those of the smoothed mesh.</p></li>\n\
</ul>\n\
<p>MRenderItem</p>\n\
<ul>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::sourceDagPath()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a9452c2cfed46b5c1977568eb5b225930&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::sourceDagPath()</a></span> always returns a dag path even when the item contains consolidated geometry (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::isConsolidated()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#acfe4fcf09654f6f6799a6966bd6b3e56&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::isConsolidated()</a></span>). When consolidated, it will return one dag path out of all dag paths contributing to the geometry. See <a href=\'#!/url=./developer/What-s-New-What-s-Changed-/What-s-New-in-API-in-Maya-2016.html#documentation-updates\' title=\'\'>Documentation updates</a> for more information regarding the extraction of dag paths and geometry from consolidated geometry during draw time.</p>\n\
<p>The use of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::sourceIndexMapping()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a9f2f2adf25777c74ddd4210bdd521b17&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::sourceIndexMapping()</a></span> is preferable since this interface returns an appropriate list of dag paths.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"textures\"></a><h4 id=\"textures\">Textures</h4></div>\n\
<p>MTextureManager</p>\n\
<ul>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTextureManager::acquireTexture()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_texture_manager.html#a04aa3cfef217948abc8edd0f19565f95&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTextureManager::acquireTexture()</a></span> method:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">MTexture* MTextureManager::acquireTexture(const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; textureName, const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; plug, int width, int height, bool generateMipMaps = true);\n\
</pre></div><p>has been modified so that if a plug to a file texture node is specified, then an attempt will be made to read the file texture from disk. Previously, this method would bake the texture using the Maya Software renderer&#39;s convert to solid texture functionality. This modification allows for better fidelity and accuracy of the returned texture.</p></li>\n\
<li><p>A new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTextureManager::acquireTexture()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_texture_manager.html#a04aa3cfef217948abc8edd0f19565f95&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTextureManager::acquireTexture()</a></span> method:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">MTexture* MTextureManager::acquireTexture(const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp; textureNode, bool allowBackgroundLoad = false); \n\
</pre></div><p>loads the file texture from a given texture node, and is the preferred method for file textures (over the previously mentioned plug method), as it provides a simpler interface. It takes a file texture node as an argument, and removes the requirement to specify parameters that are not needed (width, height, name, and generate mipmaps).</p>\n\
<p>In addition, it exposes the option to indicate whether the Viewport 2.0 texture background loading feature should be used. See <em>Material Loading Mode</em> in the <em>Display preferences</em> section of the <em>Maya User Guide</em> for more information regarding texture background loading.</p></li>\n\
<li><p>The new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTexture::update()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_texture.html#a3d365396b4e87bce3f2c6b8d93ea4d69&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTexture::update()</a></span> method:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> MTexture::update(const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp; textureNode);\n\
</pre></div><p>allows for update versus acquisition using a file texture node.</p>\n\
<p>Currently, all file texture based methods have the limitation that they return the first tile if the file texture uses UV tiling.</p></li>\n\
<li>See the <em>hwApiTextureTest</em> developer kit example for a demonstration of how to use these methods. This plug-in example includes a <span class=\'code\'>-n</span> / <span class=\'code\'>-nodeLoad</span> option that attempts to acquire <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTexture</a></span> references from existing file texture nodes in a scene. This option also attempts to create baked textures from selected procedural nodes by sampling its <span class=\'code\'>outColor</span> attribute.</li>\n\
<li><p>See the <em>viewOverrideTrackTexture</em> developer kit example. This is a plug-in render override which, when active, will try and find the first file texture node in the scene and acquire or update an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTexture</a></span>. This <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTexture</a></span> is used for a quad render operation which is the main operation used for the render override.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"lighting\"></a><h4 id=\"lighting\">Lighting</h4></div>\n\
<p>In Maya 2016 Extension 2, Viewport 2.0 only evaluates lights up to the light limit. Therefore, if you want to request light information on demand, you must call the new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::needEvaluateAllLights()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ad3ef90830d42d36701abb67d53748f08&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::needEvaluateAllLights()</a></span> method.</p>\n\
<p>If your plug-in calls the following interfaces:</p>\n\
<ul>\n\
<li><p><span class=\'code\'>MDrawContext::getLightInformation(kFilterIgnoreLightLimit)</span></p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::setLightsAndShadowsDirty()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a06b742a8850af64d01e3fcbd9450916f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::setLightsAndShadowsDirty()</a></span></p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::setLightRequiresShadows()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ac777540ab7b1bca5d51f7d03e62b4643&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::setLightRequiresShadows()</a></span></p></li>\n\
</ul>\n\
<p>You must first call this method before drawing.</p>\n\
<p>If you do not want to modify your existing plug-in, you can also set an optionVar MAYA_VP2_IGNORE_EVALUATION_LIGHT_LIMIT=1 to ensure that your plug-in continues to work as it did before Extension 2. When this optionVar is set, all lights in your scene are evaluated at all times, regardless of whether you have loaded a plug-in. As a result, this optionVar may decrease the performance of Viewport 2.0 if you have a scene with many lights.</p>\n\
<p>To mitigate this, you can set this optionVar to 0 again when your plug-in no longer needs to evaluate all lights, and Viewport 2.0 will revert back to only evaluating lights up to the light limit.</p>\n\
<div class=\'section\'><a id=\"geometry\"></a><h4 id=\"geometry\">Geometry</h4></div>\n\
<ul>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGeometryExtractor</a></span> now supports the following:</p>\n\
<ul>\n\
<li>Multiple UV map sets for texture co-ordinates in plug-in shaders</li>\n\
<li>Named map sets for Tangent and Binormal co-ordinates in plug-in shaders</li>\n\
</ul>\n\
<p>The <em>geometryReplicator</em> example plug-in demonstrates the support of these new features.</p></li>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSubSceneOverride::setGeometryForRenderItem()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_sub_scene_override.html#a0bf2b383d48c8a4b554376626e4c7a40&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSubSceneOverride::setGeometryForRenderItem()</a></span> interface has been updated so that when geometry is defined for drawing using a vertex buffer, for example by using <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometry::kPoints\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1ea57a311fc6dd7498f2339ab45af414377&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGeometry::kPoints</a></span>, then it is no longer mandatory to also provide an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIndexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIndexBuffer</a></span>. In this case, you can simply provide an empty <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIndexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIndexBuffer</a></span> to avoid wasting GPU memory. See the <em>gpuCache</em> Developer Kit plug-in for an example implementation.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"locators\"></a><h4 id=\"locators\">Locators</h4></div>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxLocatorNode::draw()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_locator_node.html#a999efab3ad8289b53bc370aaeb7d6146&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxLocatorNode::draw()</a></span> will now be passed the appropriate <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"M3dView::DisplayStyle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html#a1b68f8823b8e275a4b548fdd27263e8a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">M3dView::DisplayStyle</a></span> instead of always receiving the set <span class=\'code\'>kWireframe</span>.</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"cameras\"></a><h4 id=\"cameras\">Cameras</h4></div>\n\
<ul>\n\
<li>Added the following functions to obtain un-normalized clip values:\n\
<ul>\n\
<li>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::unnormalizedNearClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a1329b457d65a26bac707a26908cbc5d4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnCamera::unnormalizedNearClippingPlane()</a></span> function returns the distance to the near clipping plane.</li>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::unnormalizedFarClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#af6f43d59313ce37fe5e8bf75f67d6374&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnCamera::unnormalizedFarClippingPlane()</a></span> function returns the distance to the far clipping plane.</p>\n\
<p>Normalized clip planes may be computed for camera sets. This is the value returned by the existing <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::nearClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a7189bcaad0276cd50d0d67b69e572ddd&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnCamera::nearClippingPlane()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::farClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a7004b2dc7ca4d68be2f656b171d6eaba&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnCamera::farClippingPlane()</a></span> methods. These new methods allow access to the original camera&#39;s clipping planes.</p></li>\n\
</ul></li>\n\
<li><p>New methods to get the clip planes and unnormalized clip planes are now available as part of the draw context for Viewport 2.0.</p>\n\
<p>The following enums have been added to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext</a></span>:</p>\n\
<ul>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::kViewNearClipValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670a271c6ae34d0c5b65c0434314cf0fa51e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::kViewNearClipValue</a></span> //!&lt; Camera near clip value (single value)</p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::kViewFarClipValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670a31fc50b8df245a93adf2b1dd617bacd8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::kViewFarClipValue</a></span> //!&lt; Camera far clip value (single value)</p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::kViewUnnormlizedNearClipValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670ab2b11196237108d7c893c6940cfe4b16&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::kViewUnnormlizedNearClipValue</a></span> //!&lt; Unnormalized camera near clip value (single value)</p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::kViewUnnormalizedFarClipValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670a973730135c8d1f08c5de00aa2997e914&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext::kViewUnnormalizedFarClipValue</a></span> //!&lt; Unnormalized camera far clip value (single value)</p></li>\n\
</ul>\n\
<p>which can be used from the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::getTuple()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#a3a2746b602eb8dd543fa0a74497614d1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawContext::getTuple()</a></span> method.</p>\n\
<p>These produce the same results as when using <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::nearClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a7189bcaad0276cd50d0d67b69e572ddd&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnCamera::nearClippingPlane()</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::farClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a7004b2dc7ca4d68be2f656b171d6eaba&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnCamera::farClippingPlane()</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::unnormalizedNearClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a1329b457d65a26bac707a26908cbc5d4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnCamera::unnormalizedNearClippingPlane()</a></span>, and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::unnormalizedFarClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#af6f43d59313ce37fe5e8bf75f67d6374&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnCamera::unnormalizedFarClippingPlane()</a></span> respectively.</p>\n\
<p>See the <em>rawfootPrintNode</em> example plug-in for more information. See also <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Camera-information-in-relation.html\' title=\'\'>Camera information</a>.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"render-overrides\"></a><h4 id=\"render-overrides\">Render overrides</h4></div>\n\
<p>MQuadRender</p>\n\
<ul>\n\
<li>A fix has been made to help prevent memory leaks for shader instances used with quad render operations for <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOverride</a></span>s.</li>\n\
<li><p>A fix has been made to ensure that if any <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderTarget\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderTarget</a></span> specified in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation::targetOverrideList()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html#a6e61af973ca8990c8c1a389f60a31798&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOperation::targetOverrideList()</a></span> method is also specified as an input to the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance</a></span> returned from <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQuadRender::shader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_quad_render.html#a46e435a8099cf62da3e2efc815032d2b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQuadRender::shader()</a></span>, then there will not be any issues with reading and writing from the same target during rendering.</p>\n\
<p>See the <em>viewRenderOverride</em> and <em>viewRenderOverridePostColor</em> developer kit examples.</p></li>\n\
<li>A new plug-in example has been added to show how an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOverride</a></span> can use an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender</a></span> along with a series of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQuadRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_quad_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_quad_render.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQuadRender</a></span>s to perform post scene color effects. See <em>viewRenderOverridePostColor</em> in the developer kit and <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Plug-in-Entry-Points/Render-Loop-Overrides.html#post-scene-render-color-operations\' title=\'\'>Post scene render color operations</a>.</li>\n\
<li><p>Previously, if a scene or quad render operation specifies a render target that is larger than the current output target (for example, the viewport), this resulted in the operation drawing to a subset of pixels in the output target. This has been fixed.</p>\n\
<p>See the <em>viewRenderOverrideMRT</em> plug-in for sample code that draws to custom output targets that are larger than the active output target size.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"implement-an-mrenderoverride\"></a><h5 id=\"implement-an-mrenderoverride\">Implement an MRenderOverride</h5></div>\n\
<p>It is now easier to implement an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOverride</a></span>. New classes and interfaces have been added that allow you to create a render override by populating a list of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOperation</a></span>s. To create this list, you can obtain the list of standard viewport operations, and then optionally add to it your own custom operations.</p>\n\
<p>This new method of implementation also eliminates the need for an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOverride</a></span> to manage and create render targets, as these are now managed by <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOperation</a></span>.</p>\n\
<p>New classes and interfaces added include:</p>\n\
<ul>\n\
<li>New <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperationList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOperationList</a></span> class that holds and owns a collection of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOperation</a></span>s.</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::getStandardViewportOperations()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a592e0903ce501733b7ff820aa2477774&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::getStandardViewportOperations()</a></span> to fill in an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperationList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOperationList</a></span> with the standard viewport operations used for non-override drawing.</li>\n\
<li><span class=\'code\'>MRenderOverride::mOperations</span> is the operation list for the override.</li>\n\
<li><span class=\'code\'>MRenderOperation::mInputTargetNames</span> and <span class=\'code\'>MRenderOperation::mOutputTargetNames</span> allow you to declare input and output target names.</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation::getInputTargetDescription()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html#aa47def779dda9e46974e39fe89ce7e59&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOperation::getInputTargetDescription()</a></span> obtains the target description to create the target for a named input.</li>\n\
</ul>\n\
<p>See <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Implement-an-MRenderOverride.html\' title=\'\'>Implementing an MRenderOverride</a>.</p>\n\
<div class=\'section\'><a id=\"tools-and-context\"></a><h4 id=\"tools-and-context\">Tools and context</h4></div>\n\
<p>MPxContext</p>\n\
<ul>\n\
<li><p>Added a new method <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxContext::doPtrMoved()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_context.html#ad2b80a6acad38c6d725a9e6a31cc52d5&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxContext::doPtrMoved()</a></span>. This method is called when the mouse moves, so that mouse movements can be used to drive a subsequent action.</p>\n\
<p>In the case of drawing, plug-ins should override this method when <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUIDrawManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUIDrawManager</a></span> is used to perform drawing in Viewport 2.0.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"tracingsequencing\"></a><h4 id=\"tracingsequencing\">Tracing/sequencing</h4></div>\n\
<p>Debug tracing information has been added for several override classes to help track evaluation order, as well as to the internal pipeline to track renderable list execution.</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxGeometryOverride</a></span> have new tracing methods (such as <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride::traceCallSequence()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html#a498335c9c0b0ff5dce6efc063769eb3b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride::traceCallSequence()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride::handleTraceMessage()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html#a4ff99ebf5c2ae4a67e7ea54547c2e10b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride::handleTraceMessage()</a></span>, and the <span class=\'code\'>ogs</span> command has a new trace option (<span class=\'code\'>-traceRenderPipeline</span> flag).</p>\n\
<p>See <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Basic-Viewport-2-0-pipeline.html\' title=\'\'>Basic Viewport 2.0 Pipeline Sequencing</a> and <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Basic-Viewport-2-0-object.html\' title=\'\'>Basic Viewport 2 Object Sequencing</a> for more information.</p>\n\
<div class=\'section\'><a id=\"profiling\"></a><h4 id=\"profiling\">Profiling</h4></div>\n\
<p>The Profiler now graphs rendering events that execute within Viewport 2.0. These events include node evaluation and UI drawables list/render list building, as well as draw events such as UV Editor drawing, beauty pass render, and UI drawables rendering (such as manipulator drawing). If you are using a render override plug-in, operations such as the quad render, 3d scene render and HUD render are also presented.</p>\n\
<p>This feature allows you to identify render events or passes that may be performance bottlenecks in your scene</p>\n\
<p>To filter these events, search for the prefix Vp2.</p>\n\
<p>For more information on rendering events in Viewport 2.0, as well as information on what each event represents, see <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Profile-Viewport-2-0-rendering.html\' title=\'\'>Profile Viewport 2.0 rendering events</a> and <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Profile-Viewport-2-0-rendering/Viewport-2-0-rendering-events.html\' title=\'\'>Viewport 2.0 rendering events Profiler examples</a>.</p>\n\
<div class=\'section\'><a id=\"render-setup\"></a><h4 id=\"render-setup\">Render Setup</h4></div>\n\
<p>A new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderSetup\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_render_setup.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderSetup</a></span> class has been added that allows for access to Maya&#39;s new render setup functionality.</p>\n\
<div class=\'section\'><a id=\"performance-improvements-for-viewport-2.0-api-plug-ins\"></a><h3 id=\"performance-improvements-for-viewport-2.0-api-plug-ins\">Performance improvements for Viewport 2.0 API plug-ins</h3></div>\n\
<ul>\n\
<li><p>A new <span class=\'code\'>isAlwaysDirty</span> parameter has been added to the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride</a></span> constructor. To optimize performance, set this attribute to false so that the draw override is only updated when the node is marked dirty via DG evaluation or dirty propagation. To explicitly mark an object as being dirty, call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::setGeometryDrawDirty()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ab2843a350b76cdcbf16dd70d884f9766&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::setGeometryDrawDirty()</a></span>.</p>\n\
<p>See the <em>transformDrawNode</em> developer kit example for more information.</p></li>\n\
<li>The <em>viewImageBlitOverride</em> plug-in example has been modified to show a more performant path of blitting a textured image once instead of trying to show update options. A HUD draw has been added as well.</li>\n\
<li><p>Performance is improved in scenes with many instances of nodes and that draw using <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxDrawOverride</a></span>.</p></li>\n\
<li><p>Performance improvement for viewport override plug-ins using the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderOverride</a></span> interface.</p></li>\n\
<li><p>Previously, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSubSceneOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_sub_scene_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_sub_scene_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSubSceneOverride</a></span> could not leverage Maya&#39;s geometry consolidation system. New <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setWantSubSceneConsolidation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#acfca7df96b38a12712ddbf974af6ce77&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::setWantSubSceneConsolidation()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::wantSubSceneConsolidation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a627aca1fe5775cca0f2f816c84794e0a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::wantSubSceneConsolidation()</a></span> methods are now available on <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem</a></span>. This flag only affects items that will be or are already added to an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSubSceneContainer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_sub_scene_container.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_sub_scene_container.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSubSceneContainer</a></span>. When set, these render items will be eligible for consolidation.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"developer-kit-examples\"></a><h3 id=\"developer-kit-examples\">Developer Kit examples</h3></div>\n\
<ul>\n\
<li>The <em>rawfootPrintNode</em> plug-in has been updated to demonstrate raw drawing in Core Profile mode. This plug-in demonstrates how different OpenGL Core Profile is from legacy Open GL in that it draws without using glBegin/glVertex/glEnd. The new technique is similar to that of DX11.</li>\n\
<li><p>The example plug-in <em>fragmentDumper</em> has also been updated to include the ability to dump the XML for a fragment with the specified name, as well as the ability to provide a list of all fragment names.</p></li>\n\
<li><p>The <em>viewObjectSetOverride</em> plug-in has been modified to illustrate how to handle isolate selection in <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender::objectSetOverride()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html#a138c3fea5fc4e4371e11809ceb4cb30c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSceneRender::objectSetOverride()</a></span>.</p>\n\
<p>An object selected for isolate selection will only be shown if it also belongs to the specified object set; that is, set1 and set2.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"documentation-updates\"></a><h3 id=\"documentation-updates\">Documentation updates</h3></div>\n\
<ul>\n\
<li><p>Information regarding camera orientation in relation to the DirectX and OpenGL draw API&#39;s has been added to <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Camera-information-in-relation.html\' title=\'\'>Camera information</a>.</p></li>\n\
<li><p>Information regarding shader consolidation has been added to <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Plug-in-Entry-Points/Effect-Overrides.html#consolidation-considerations\' title=\'\'>Effect overrides: Consolidation considerations</a> and <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/API-constructs/Shader-Instances.html#consolidation-considerations\' title=\'\'>Shader instances: Consolidation considerations</a>.</p></li>\n\
<li>The <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Plug-in-Entry-Points/UI-draw-manager.html\' title=\'\'>UI draw manager</a> topic has been updated to include information such as the pros and cons of using <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUIDrawManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUIDrawManager</a></span> versus <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem</a></span>.</li>\n\
<li>A new <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Geometry-remapping-for-hardware.html\' title=\'\'>Geometry remapping for hardware rendering</a> topic has been added to include information as to how vertex data provided at render time can be mapped back to the original geometry.</li>\n\
<li><p>Information about post effects passes added to <a href=\'#!/url=./developer/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Effects-interfaces.html\' title=\'\'>Effects interfaces</a>.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"animation\"></a><h2 id=\"animation\">Animation</h2></div>\n\
<div class=\'section\'><a id=\"gpu-override\"></a><h3 id=\"gpu-override\">GPU Override</h3></div>\n\
<p>Added the following functions for tracking the GPU memory usage:</p>\n\
<ul>\n\
<li>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::holdGPUMemory()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ab4c1def24e934781098b800fd8b16cdd&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::holdGPUMemory()</a></span> function allows a plug-in to report that the total amount of GPU memory allocated to it is increasing in bytes.</li>\n\
<li>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::releaseGPUMemory()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a539094d46be4675c5690419f1c09b38e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::releaseGPUMemory()</a></span> function allows a plug-in to report that the total amount of GPU memory allocated to it is decreasing in bytes.</li>\n\
</ul>\n\
<p>Note: To avoid running out of GPU memory, Maya GPU buffers might be moved to system memory when GPU memory is almost full. This process relies on accurately tracking the GPU memory usage.</p>\n\
<ul>\n\
<li>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer::GPUtotalMemorySize()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#ab546dd529d63c97ade26f0b87c0c03d7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer::GPUtotalMemorySize()</a></span> function retrieves the total amount of GPU memory in bytes on a graphics card.</li>\n\
</ul>\n\
<p>New convenience class that makes allocating, updating, and releasing OpenCL buffers easy</p>\n\
<ul>\n\
<li>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MOpenCLBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_open_c_l_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MOpenCLBuffer</a></span> class that can replace calls to <span class=\'code\'>clCreateBuffer</span>, <span class=\'code\'>clEnqueueWriteBuffer</span>, and <span class=\'code\'>clReleaseBuffer</span>. It automatically tracks the GPU memory usage, so you do not have to call the interface on <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_renderer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderer</a></span>.</li>\n\
</ul>\n\
<p>Added the following functions to get correct behavior in certain scenarios without having to turn off and turn on the GPU override:</p>\n\
<ul>\n\
<li>The new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerRegistrationInfo::validateNodeInGraph()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_registration_info.html#af612f89c960cf432dc7be0d3f1be8d93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerRegistrationInfo::validateNodeInGraph()</a></span> function is called only when the topology of the Dependency Graph (DG) changes. For example, when connections are added or removed, or when nodes are added or removed.</li>\n\
<li>The new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerRegistrationInfo::validateNodeValues()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_registration_info.html#a5211d6842c7677f9730a9c76cb258568&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerRegistrationInfo::validateNodeValues()</a></span> function is called when an attribute on a node changes either through animation or user manipulation.</li>\n\
</ul>\n\
<p>Note: The <span class=\'code\'>MGPUDeformerRegistrationInfo::validateNode()</span> function has been removed.</p>\n\
<ul>\n\
<li>The new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerRegistry::addConditionalAttribute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_registry.html#a2e96bdde07077e4af65457c6edb9c11a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerRegistry::addConditionalAttribute()</a></span> function is called for adding a conditional attribute to a registered GPU deformer. A conditional attribute is a deformation node that supports some values of an attribute, but not all. For example, an envelope (a scale factor that determines the influence of a deformer) that only supports the 0.0f value and 1.0f value, but no other values. When the value of a conditional attribute changes, the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerRegistrationInfo::validateNodeValues()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_registration_info.html#a5211d6842c7677f9730a9c76cb258568&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerRegistrationInfo::validateNodeValues()</a></span> function is called to determine if the node is now supported. If it is supported, the deformation chains in the GPU override are rebuilt to add the newly supported node.</li>\n\
</ul>\n\
<p>Function to detect change in attributes</p>\n\
<ul>\n\
<li>Added a new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGPUDeformer::hasAttributeBeenModified()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_g_p_u_deformer.html#abb7238dc52214c1b33a9c4000c1f237e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxGPUDeformer::hasAttributeBeenModified()</a></span> function to detect change in attributes. This function returns true if an attribute is animated or if an attribute&#39;s value has interactively changed since the last call to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGPUDeformer::evaluate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_g_p_u_deformer.html#a070259639bc552fd702c9e8e042f0331&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxGPUDeformer::evaluate()</a></span> for an evaluation node.</li>\n\
</ul>\n\
<p>Added the following functions in the MOpenCLInfo class to localize strings.</p>\n\
<ul>\n\
<li>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MOpenCLInfo::getOpenCLKernelFromString()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_open_c_l_info.html#a5ec5031fba36b59d5e2c548a0ef18463&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MOpenCLInfo::getOpenCLKernelFromString()</a></span> function compiles a string into a <span class=\'code\'>cl_program</span>, and then creates a <span class=\'code\'>cl_kernel</span> from one of the kernels in that program.</li>\n\
<li>The new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MOpenCLInfo::appendMessage()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_open_c_l_info.html#a8682346bb79641242ffc37e0b163f136&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MOpenCLInfo::appendMessage()</a></span> function appends a message to messages. The message is created using <span class=\'code\'>formatResourceId</span> and additional arguments.</li>\n\
</ul>\n\
<p>MOpenCLInfo interface name change</p>\n\
<ul>\n\
<li>The <span class=\'code\'>MOpenCLInfo:: getOpenCLCommandQueue()</span> method has been renamed to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MOpenCLInfo::getMayaDefaultOpenCLCommandQueue()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_open_c_l_info.html#a93e129c1488b06f3347eaaad703ffe34&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MOpenCLInfo::getMayaDefaultOpenCLCommandQueue()</a></span>.</li>\n\
</ul>\n\
<p>MultiDraw consolidation support</p>\n\
<ul>\n\
<li><p>MultiDraw consolidation is supported for <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span>. An <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride</a></span> plug-in based on <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance</a></span>s can now benefit from acceleration provided by MultiDraw consolidation if it can provide a MultiDraw-compatible MShaderInstance.</p>\n\
<p>The following interfaces have been added for this feature:</p>\n\
<ul>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride::supportsMultiDraw()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html#a74828e53545b3cf4dea69c7cd542cde7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride::supportsMultiDraw()</a></span></p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::isMultiDraw()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#a7d0fc38902e84515879ea33cb99960a5&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawContext::isMultiDraw()</a></span></p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::isMultiDraw()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a7d0fc38902e84515879ea33cb99960a5&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::isMultiDraw()</a></span></p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride::multiDrawNonTexturedShaderInstance()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html#addb7495495666cb089e7d2cf7f4c4a7c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride::multiDrawNonTexturedShaderInstance()</a></span></p></li>\n\
<li><p><span class=\'code\'>MPxShaderOverride::shaderInstance(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MHWRender::MDrawContext</a>&amp; context)</span></p></li>\n\
</ul>\n\
<p>And this interface has been deprecated:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride::shaderInstance()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html#a6d02252408ad23749646cea8cc2d36fc&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride::shaderInstance()</a></span></li>\n\
</ul>\n\
<p>New shader semantics have also been added that are MultiDraw versions of world transformation, world-view transformation, and world-view-projection transformation matrices. See <a href=\'#!/url=./developer/Viewport-2-0-API/Shader-semantics-supported-by.html\' title=\'\'>Shader semantics supported by Viewport 2.0</a>.</p>\n\
<p>See also the <em>customTextureShader</em> sample plug-in in the Developer Kit.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"modeling\"></a><h2 id=\"modeling\">Modeling</h2></div>\n\
<div class=\'section\'><a id=\"openmaya\"></a><h3 id=\"openmaya\">OpenMaya</h3></div>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsCurve::findLengthFromParam()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_curve.html#a5bdb846d7b4dc19e69b32e2d2201f340&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNurbsCurve::findLengthFromParam()</a></span> method has been added that returns, for a given parameter value, the length along the curve.</li>\n\
</ul>\n\
<p>Updated the MFnBlendShapeDeformer interface</p>\n\
<ul>\n\
<li>Added the following to the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBlendShapeDeformer::HistoryLocation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_blend_shape_deformer.html#aecd5328f224e56ed7679b090606f222e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnBlendShapeDeformer::HistoryLocation</a></span> enum:\n\
<ul>\n\
<li><span class=\'code\'>kPost</span> - for post-deformation</li>\n\
<li><span class=\'code\'>kOther</span> - for other deformation order</li>\n\
</ul></li>\n\
<li>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBlendShapeDeformer::TargetType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_blend_shape_deformer.html#a0d59972970c855496cb4c877501e668f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnBlendShapeDeformer::TargetType</a></span> enum for target type (<span class=\'code\'>kObject</span> or <span class=\'code\'>kTangent</span>).</li>\n\
<li>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBlendShapeDeformer::historyLocation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_blend_shape_deformer.html#afb813583370f58bed4a8500a8b21cf10&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnBlendShapeDeformer::historyLocation()</a></span> method to get the history location (deformation order).</li>\n\
<li>Added the <span class=\'code\'>targetType</span> parameter in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBlendShapeDeformer::addTarget()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_blend_shape_deformer.html#ac93f9f0876569f29c29ff68c58de9e70&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnBlendShapeDeformer::addTarget()</a></span> function to specify a target type (<span class=\'code\'>Object</span> or <span class=\'code\'>Tangent</span>) for the target. The default type is <span class=\'code\'>Object</span>.</li>\n\
<li><p>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBlendShapeDeformer::addTarget()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_blend_shape_deformer.html#ac93f9f0876569f29c29ff68c58de9e70&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnBlendShapeDeformer::addTarget()</a></span> function to add a new delta target object without specifying a new target object for the given base object. In this case, a new target with 0 delta from base is added.</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBlendShapeDeformer::addTarget\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_blend_shape_deformer.html#ac93f9f0876569f29c29ff68c58de9e70&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnBlendShapeDeformer::addTarget</a> (const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp;  baseObject,  \n\
        int  weightIndex,  \n\
        double  fullWeight,  \n\
        TargetType  targetType = kObject)</pre></div></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"user-interface\"></a><h2 id=\"user-interface\">User interface</h2></div>\n\
<ul>\n\
<li><p>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil::createPixmap()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html#a7fe6b8c9a59baff474e443350d94b771&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil::createPixmap()</a></span> method that looks up an image based on its name as well as the DPI if the <span class=\'code\'>autoScale</span> parameter is set to true.</p>\n\
<p>For example: calling <span class=\'code\'>createPixmap(&quot;test.png&quot;, true)</span> may return <span class=\'code\'>test_150.png</span> if the scale factor is 150%.</p></li>\n\
<li><p>Added two <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil::dpiScale()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html#a23629cfbd1337311e259f247ca81667d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil::dpiScale()</a></span> methods (int and float) to get the scaled size for Maya interface scaling. These methods return the scaled size in Qt.</p></li>\n\
<li><p>A new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFileIO::setError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_file_i_o.html#a37189da8c53c630aea7bd9a738253a33&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFileIO::setError()</a></span> method has been added that, when set, allows you to display the standard Maya file I/O pop-up window if an error occurs after a read or write operation. This method can only be invoked during a file I/O operation.</p>\n\
<p>It is also recommended that you call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a4ddbe97e58a90e1ab05d45a62c006cf0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayError()</a></span> when invoking <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFileIO::setError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_file_i_o.html#a37189da8c53c630aea7bd9a738253a33&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFileIO::setError()</a></span> since the pop up window only contains a static message that refers the user to the Script Editor for more information.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"general\"></a><h2 id=\"general\">General</h2></div>\n\
<p>New MRandom namespace</p>\n\
<ul>\n\
<li><p>The new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRandom\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_random.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRandom</a></span> class provides interfaces to generate sequences of random numbers.</p>\n\
<p>Unlike traditional PRNGs, which cannot be easily parallelized, this algorithm allows for parallelization as it does not require that n-1 be generated in order to generate n. It is very fast and passes statistical tests on randomness, and in addition, you can obtain the same result each time you call this function with the same arguments.</p></li>\n\
</ul>\n\
<p>New methods for working with double precision meshes</p>\n\
<ul>\n\
<li>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh::getRawDoublePoints()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html#a331efdb89bf9c388c7825d4a898a4a41&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh::getRawDoublePoints()</a></span> method that returns a pointer to the internal vertex list of a mesh.</li>\n\
<li><p>New overload of the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh::create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html#af9b9e5d33d289134d567c62bad4ca3d5&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh::create()</a></span> method.</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> MFnMesh::create (int numVertices, int numPolygons, const <a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPointArray</a> &amp;vertexArray, const <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_int_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> &amp;polygonCounts, const <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_int_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> &amp;polygonConnects, bool storeDoubles, <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> parentOrOwner, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus)</span></p></li>\n\
<li><p>The following functions have been added to the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFileObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_file_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_file_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFileObject</a></span> class in both the C++ and Python API. Raw URI information can now be accessed via <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxFileResolver\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_file_resolver.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxFileResolver</a></span>:</p>\n\
<ul>\n\
<li><p><span class=\'code\'>MFileObject::setRawURI( const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp; uri )</span></p></li>\n\
<li><p><span class=\'code\'>MFileObject::setRawURI( const <a href=\"javascript:void(0)\" data-symbol=\"MURI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_u_r_i.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_u_r_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MURI</a> &amp; uri )</span></p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFileObject::rawURI()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_file_object.html#aa947f818bddfd78820b2d722a022eb13&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFileObject::rawURI()</a></span></p></li>\n\
</ul></li>\n\
<li><p>The following multiplication operator functions have been added:</p>\n\
<p>MPoint</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(const int scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(const short scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(const unsigned int scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(const unsigned short scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(const float scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp; operator*=(const int);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp; operator*=(const short);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp; operator*=(const unsigned int);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp; operator*=(const unsigned short);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp; operator*=(const float);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp; operator*=(const double);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(int, const <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp;);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(short, const <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp;);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(unsigned int, const <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp;);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(unsigned short, const <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp;);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> operator*(float, const <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a> &amp;);</span></li>\n\
</ul>\n\
<p>MFloatPoint</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*(const int scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*(const short scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*(const unsigned int scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*(const unsigned short scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*(const double scale) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp; operator*=(const int);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp; operator*=(const short);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp; operator*=(const unsigned int);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp; operator*=(const unsigned short);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp; operator*=(const float);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp; operator*=(const double);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*( int, const <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp;);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*( short, const <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp;);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*( unsigned int, const <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp;);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*( unsigned short, const <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp;);</span></li>\n\
<li>friend function <span class=\'code\'>OPENMAYA_EXPORT <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> operator*( double, const <a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPoint</a> &amp;);</span></li>\n\
</ul>\n\
<p>MVector</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a>&amp; operator*=(int scalar);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a>&amp; operator*=(short scalar);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a>&amp; operator*=(unsigned int scalar);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a>&amp; operator*=(unsigned short scalar);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a>&amp; operator*=(float scalar);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a> operator*(int scalar) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a> operator*(short scalar) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a> operator*(unsigned int scalar) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a> operator*(unsigned short scalar) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MVector</a> operator*(float scalar) const;</span></li>\n\
</ul>\n\
<p>MFloatVector</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a>&amp; operator*=( int scalar );</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a>&amp; operator*=( short scalar );</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a>&amp; operator*=( unsigned int scalar );</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a>&amp; operator*=( unsigned short scalar );</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a>&amp; operator*=( double);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a> operator*( int scalar ) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a> operator*( short scalar ) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a> operator*( unsigned int scalar ) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a> operator*( unsigned short scalar ) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a> operator*( double scalar ) const;</span></li>\n\
</ul>\n\
<p>The following new interfaces have been added to MPlug:</p>\n\
<ul>\n\
<li>Finds the source plug that is driving this plug:\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug::source()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html#ae1a22944dd4daea3988e3a04ff4d10a8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug::source()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug::sourceWithConversion()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html#ab5816fdca5b5269b9335cabba55a9acd&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug::sourceWithConversion()</a></span></li>\n\
</ul></li>\n\
<li><p>Finds the destination plugs, the values of which are driven by this one:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug::destinations()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html#afd8b1e1dd10d83d9da13ec84bdc2a5a3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug::destinations()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug::destinationsWithConversions()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html#a815882d306ddc342eee53d776877f750&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug::destinationsWithConversions()</a></span></li>\n\
</ul>\n\
<p>These methods are similar to the existing <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug::connectedTo()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html#acf1340576a4a0a78a0045e67ee4155bf&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug::connectedTo()</a></span> method in that they produce the networked version of the connected plugs.</p>\n\
<p>However, they offer the additional advantage that two of these methods: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug::source()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html#ae1a22944dd4daea3988e3a04ff4d10a8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug::source()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug::destinations()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html#afd8b1e1dd10d83d9da13ec84bdc2a5a3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug::destinations()</a></span> allow you to ignore unit conversion nodes when making connection queries.</p>\n\
<p>These methods are also supported in Python API 2.0.</p></li>\n\
</ul></li>\n\
</ul>\n\
<p>Added the following functions to mute reference edits in a file reference node temporarily:</p>\n\
<ul>\n\
<li>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnReference::ignoreReferenceEdits()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_reference.html#a465e63f226916ddda4be0b8dd0a7dfe0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnReference::ignoreReferenceEdits()</a></span> method indicates whether reference edits are tracked and logged.</li>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnReference::setIgnoreReferenceEdits()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_reference.html#a8bfd33e655f4b2168f696b2760e8a559&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnReference::setIgnoreReferenceEdits()</a></span> method specifies whether reference edits must be tracked and logged.</p>\n\
<p>These methods are also supported in Python API 2.0.</p></li>\n\
<li><p>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle::copyWritable()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html#aea38af7f03b828cb6e53cdbda13c5da8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle::copyWritable()</a></span> method that copies an attribute from the <span class=\'code\'>src</span> attribute to the attribute referenced by the handle.</p>\n\
<p>This method is also supported in Python API 2.0.</p></li>\n\
</ul>\n\
<p>Added the following functions to create a proxy attribute:</p>\n\
<ul>\n\
<li>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute::setProxyAttribute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html#a60db28e1afc8251b18a2d6ca12738780&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnAttribute::setProxyAttribute()</a></span> function states whether an attribute is a proxy attribute.</li>\n\
<li><p>The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute::isProxyAttribute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html#aad284ddebdfcebe44a94c74bac745cd7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnAttribute::isProxyAttribute()</a></span> function returns true if an attribute is a proxy attribute.</p>\n\
<p>Note:</p>\n\
<p><span class=\'code\'>MFnAttribute.isProxyAttribute</span> is also available in Python API 2.0 as an attribute. You can therefore set or get the value as follows:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># Set the attribute\n\
myObj.isProxyAttribute = True\n\
\n\
# Get the attribute\n\
myBool = myObj.isProxyAttribute</pre></div></li>\n\
<li><p>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier::renameAttribute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html#a8525e8a000cc90b279a2d52b01b12696&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGModifier::renameAttribute()</a></span> method for renaming a dynamic attribute on a given dependency node.</p>\n\
<p>This method is also supported in Python API 2.0.</p></li>\n\
<li>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFileIO::setError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_file_i_o.html#a37189da8c53c630aea7bd9a738253a33&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFileIO::setError()</a></span> method that sets the internal <span class=\'code\'>errorIO</span> flag.</li>\n\
<li>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFn::kCombinationShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a1e5d07fc0e776e4ba7f5f7d08d181aae&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kCombinationShape</a></span> enumerator to the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFn::Type\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::Type</a></span> enumeration.</li>\n\
<li><p>Added the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute::acceptsAttribute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html#a5311597e8b5cde20a24cb5221ef70c39&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnAttribute::acceptsAttribute()</a></span> method that returns true if an attribute can accept a connection with a given attribute.</p>\n\
<p>This method is also supported in Python API 2.0.</p></li>\n\
<li>Added the <span class=\'code\'>extraMenuItemParams</span> parameter in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin::addMenuItem()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html#a643557a7145a48bbfde41804195c0a4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin::addMenuItem()</a></span> method to specify parameters for creating the <span class=\'code\'>menuItem</span>.</li>\n\
<li><p>Added the new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxMultiPolyTweakUVCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_multi_poly_tweak_u_v_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxMultiPolyTweakUVCommand</a></span> class for UV options.</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"developer-kit-example-update\"></a><h3 id=\"developer-kit-example-update\">Developer Kit example update</h3></div>\n\
<p>The Alembic version has been upgraded to 1.5.8. The <em>AbcExport</em> and <em>AbcImport</em> plug-ins now have the ability to import/export UV sets.</p>\n\
<div class=\'section\'><a id=\"effects-and-painting\"></a><h2 id=\"effects-and-painting\">Effects and painting</h2></div>\n\
<p>The new <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPaintMessage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_paint_message.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_paint_message.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPaintMessage</a></span> class has been added that allows you to register callbacks for vertex color paining. See the <em>paintCallback</em> developer kit example for a demonstration of how to use this class.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";